/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],O=0,R=x.length;O<R;O++)e[O]=Z[x[O]];return e};define(Z[48],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(k){return(w,g,c)=>{let b=null,p=null;if(typeof c.value=="function"?(b="value",p=c.value):typeof c.get=="function"&&(b="get",p=c.get),!p)throw new Error("not supported");c[b]=k(p,g)}}function R(k,w,g){let c=null,b=null;if(typeof g.value=="function"?(c="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",b=g.get),!b)throw new Error("not supported");const p=`$memoize$${w}`;g[c]=function(...d){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[p]}}e.memoize=R;function I(k,w,g){return O((c,b)=>{const p=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...P){this[d]||(this[d]=g?g():void 0),clearTimeout(this[p]),w&&(this[d]=w(this[d],...P),P=[this[d]]),this[p]=setTimeout(()=>{c.apply(this,P),this[d]=g?g():void 0},k)}})}e.debounce=I;function D(k,w,g){return O((c,b)=>{const p=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,P=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...N){if(this[d]||(this[d]=g?g():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),w&&(this[d]=w(this[d],...N)),this[m])return;const u=this[P]+k;u<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0):(this[m]=!0,this[p]=setTimeout(()=>{this[m]=!1,this[P]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0},u-Date.now()))}})}e.throttle=D}),define(Z[70],Q([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,c){if(!g)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function I(g,c="Unreachable"){throw new Error(c)}e.assertNever=I;function D(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=D;function k(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function w(g,c){let b=0;for(;b<g.length-1;){const p=g[b],d=g[b+1];if(!c(p,d))return!1;b++}return!0}e.checkAdjacentItems=w}),define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let i=0;const n=t.length;let r="",o=0,a=16,l=0;function h(ne){let ae=0,ue=0;for(;ae<ne;){const se=t.charCodeAt(i);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;i++,ae++}return ae<ne&&(ue=-1),ue}function A(ne){i=ne,r="",o=0,a=16,l=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(ae,i),i++;break}if(ue===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ve=h(4);ve>=0?ne+=String.fromCharCode(ve):l=4;break}default:l=5}ae=i;continue}if(ue>=0&&ue<=31)if(g(ue)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function ee(){if(r="",l=0,o=i,i>=n)return o=n,a=17;let ne=t.charCodeAt(i);if(w(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(w(ne));return a=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ne){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=Y(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let se=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,se=!0;break}i++}return se||(i++,l=1),r=t.substring(ae,i),a=13}return r+=String.fromCharCode(ne),i++,a=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!c(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ne),i++,a=16}}function te(ne){if(w(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:s?ie:ee,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>l}}e.createScanner=k;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function p(t,s){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(h,A,F,Y){o.value=h,o.offset=A,o.length=F,o.type=Y,o.colonOffset=void 0,r=o}try{S(t,{onObjectBegin:(h,A)=>{if(s<=h)throw n;r=void 0,a=s>h,i.push("")},onObjectProperty:(h,A,F)=>{if(s<A||(l(h,A,F,"property"),i[i.length-1]=h,s<=A+F))throw n},onObjectEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onArrayBegin:(h,A)=>{if(s<=h)throw n;r=void 0,i.push(0)},onArrayEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onLiteralValue:(h,A,F)=>{if(s<A||(l(h,A,F,E(h)),s<=A+F))throw n},onSeparator:(h,A,F)=>{if(s<=A)throw n;if(h===":"&&r&&r.type==="property")r.colonOffset=A,a=!1,r=void 0;else if(h===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:r,isAtPropertyKey:a,matches:h=>{let A=0;for(let F=0;A<h.length&&F<i.length;F++)if(h[A]===i[F]||h[A]==="*")A++;else if(h[A]!=="**")return!1;return A===h.length}}}e.getLocation=p;function d(t,s=[],i=D.DEFAULT){let n=null,r=[];const o=[];function a(h){Array.isArray(r)?r.push(h):n!==null&&(r[n]=h)}return S(t,{onObjectBegin:()=>{const h={};a(h),o.push(r),r=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const h=[];a(h),o.push(r),r=h,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i),r[0]}e.parse=d;function P(t,s=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function o(h){return n.children.push(h),h}S(t,{onObjectBegin:h=>{n=o({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,A,F)=>{n=o({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:A,length:F,parent:n})},onObjectEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onArrayBegin:(h,A)=>{n=o({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onLiteralValue:(h,A,F)=>{o({type:E(h),offset:A,length:F,parent:n,value:h}),r(A+F)},onSeparator:(h,A,F)=>{n.type==="property"&&(h===":"?n.colonOffset=A:h===","&&r(A))},onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=P;function m(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=m;function N(t){if(!t.parent||!t.parent.children)return[];const s=N(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=N;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=u(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function y(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=y(n[r],s,i);if(o)return o}return t}}e.findNodeAtOffset=y;function S(t,s,i=D.DEFAULT){const n=k(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(q){return q?J=>q(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),l=o(s.onObjectProperty),h=r(s.onObjectEnd),A=r(s.onArrayBegin),F=r(s.onArrayEnd),Y=o(s.onLiteralValue),ee=o(s.onSeparator),te=r(s.onComment),ie=o(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ue(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ne||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(q){case 12:case 13:ne?se(10):te();break;case 16:se(1);break;case 15:case 14:break;default:return q}}}function se(q,J=[],C=[]){if(ie(q),J.length+C.length>0){let L=n.getToken();for(;L!==17;){if(J.indexOf(L)!==-1){ue();break}else if(C.indexOf(L)!==-1)break;L=ue()}}}function ve(q){const J=n.getTokenValue();return q?Y(J):l(J),ue(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(se(2),q=0)}catch{se(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ue(),!0}function j(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(ve(!1),n.getToken()===6?(ee(":"),ue(),W()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function M(){a(),ue();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),ee(","),ue(),n.getToken()===2&&ae)break}else q&&se(6,[],[]);j()||se(4,[],[2,5]),q=!0}return h(),n.getToken()!==2?se(7,[2],[]):ue(),!0}function $(){A(),ue();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),ee(","),ue(),n.getToken()===4&&ae)break}else q&&se(6,[],[]);W()||se(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?se(8,[4],[]):ue(),!0}function W(){switch(n.getToken()){case 3:return $();case 1:return M();case 10:return ve(!0);default:return B()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(se(4,[],[]),!1):W()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=S;function v(t,s){const i=k(t),n=[];let r,o=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=v;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(w,g,c){return Math.min(Math.max(w,g),c)}e.clamp=O;function R(w,g){return(g+w%g)%g}e.rot=R;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class D{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class k{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const c=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function x(I){const D=[];typeof I=="number"&&D.push("code/timeOrigin",I);function k(g){D.push(g,Date.now())}function w(){const g=[];for(let c=0;c<D.length;c+=2)g.push({name:D[c],startTime:D[c+1]});return g}return{mark:k,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(I+k.startTime)});return D}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function O(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=O(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var R in O)(typeof exports=="object"?exports:x)[R]=O[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function O(R){if(e[R])return e[R].exports;var I=e[R]={i:R,l:!1,exports:{}};return x[R].call(I.exports,I,I.exports,O),I.l=!0,I.exports}return O.m=x,O.c=e,O.d=function(R,I,D){O.o(R,I)||Object.defineProperty(R,I,{enumerable:!0,get:D})},O.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},O.t=function(R,I){if(1&I&&(R=O(R)),8&I||4&I&&typeof R=="object"&&R&&R.__esModule)return R;var D=Object.create(null);if(O.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:R}),2&I&&typeof R!="string")for(var k in R)O.d(D,k,function(w){return R[w]}.bind(null,k));return D},O.n=function(R){var I=R&&R.__esModule?function(){return R.default}:function(){return R};return O.d(I,"a",I),I},O.o=function(R,I){return Object.prototype.hasOwnProperty.call(R,I)},O.p="",O(O.s=0)}([function(x,e,O){(function(R){var I;e=x.exports=C,I=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],g=e.src=[],c=0,b=c++;g[b]="0|[1-9]\\d*";var p=c++;g[p]="[0-9]+";var d=c++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;g[P]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var m=c++;g[m]="("+g[p]+")\\.("+g[p]+")\\.("+g[p]+")";var N=c++;g[N]="(?:"+g[b]+"|"+g[d]+")";var u=c++;g[u]="(?:"+g[p]+"|"+g[d]+")";var f=c++;g[f]="(?:-("+g[N]+"(?:\\."+g[N]+")*))";var y=c++;g[y]="(?:-?("+g[u]+"(?:\\."+g[u]+")*))";var S=c++;g[S]="[0-9A-Za-z-]+";var v=c++;g[v]="(?:\\+("+g[S]+"(?:\\."+g[S]+")*))";var E=c++,t="v?"+g[P]+g[f]+"?"+g[v]+"?";g[E]="^"+t+"$";var s="[v=\\s]*"+g[m]+g[y]+"?"+g[v]+"?",i=c++;g[i]="^"+s+"$";var n=c++;g[n]="((?:<|>)?=?)";var r=c++;g[r]=g[p]+"|x|X|\\*";var o=c++;g[o]=g[b]+"|x|X|\\*";var a=c++;g[a]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var l=c++;g[l]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[y]+")?"+g[v]+"?)?)?";var h=c++;g[h]="^"+g[n]+"\\s*"+g[a]+"$";var A=c++;g[A]="^"+g[n]+"\\s*"+g[l]+"$";var F=c++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;g[Y]="(?:~>?)";var ee=c++;g[ee]="(\\s*)"+g[Y]+"\\s+",w[ee]=new RegExp(g[ee],"g");var te=c++;g[te]="^"+g[Y]+g[a]+"$";var ie=c++;g[ie]="^"+g[Y]+g[l]+"$";var ne=c++;g[ne]="(?:\\^)";var ae=c++;g[ae]="(\\s*)"+g[ne]+"\\s+",w[ae]=new RegExp(g[ae],"g");var ue=c++;g[ue]="^"+g[ne]+g[a]+"$";var se=c++;g[se]="^"+g[ne]+g[l]+"$";var ve=c++;g[ve]="^"+g[n]+"\\s*("+s+")$|^$";var B=c++;g[B]="^"+g[n]+"\\s*("+t+")$|^$";var j=c++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[a]+")",w[j]=new RegExp(g[j],"g");var M=c++;g[M]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var $=c++;g[$]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var W=c++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)I(q,g[q]),w[q]||(w[q]=new RegExp(g[q]));function J(z,G){if(z instanceof C)return z;if(typeof z!="string"||z.length>D||!(G?w[i]:w[E]).test(z))return null;try{return new C(z,G)}catch{return null}}function C(z,G){if(z instanceof C){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof C))return new C(z,G);I("SemVer",z,G),this.loose=G;var X=z.trim().match(G?w[i]:w[E]);if(!X)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<k)return pe}return he}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=J,e.valid=function(z,G){var X=J(z,G);return X?X.version:null},e.clean=function(z,G){var X=J(z.trim().replace(/^[=v]+/,""),G);return X?X.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof C||(z=new C(z,this.loose)),this.compareMain(z)||this.comparePre(z)},C.prototype.compareMain=function(z){return z instanceof C||(z=new C(z,this.loose)),T(this.major,z.major)||T(this.minor,z.minor)||T(this.patch,z.patch)},C.prototype.comparePre=function(z){if(z instanceof C||(z=new C(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],he=z.prerelease[G];if(I("prerelease compare",G,X,he),X===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(X===void 0)return-1;if(X!==he)return T(X,he)}while(++G)},C.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,G,X,he){typeof X=="string"&&(he=X,X=void 0);try{return new C(z,X).inc(G,he).version}catch{return null}},e.diff=function(z,G){if(K(z,G))return null;var X=J(z),he=J(G);if(X.prerelease.length||he.prerelease.length){for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return pe},e.compareIdentifiers=T;var L=/^[0-9]+$/;function T(z,G){var X=L.test(z),he=L.test(G);return X&&he&&(z=+z,G=+G),X&&!he?-1:he&&!X?1:z<G?-1:z>G?1:0}function U(z,G,X){return new C(z,X).compare(new C(G,X))}function V(z,G,X){return U(z,G,X)>0}function H(z,G,X){return U(z,G,X)<0}function K(z,G,X){return U(z,G,X)===0}function re(z,G,X){return U(z,G,X)!==0}function ce(z,G,X){return U(z,G,X)>=0}function we(z,G,X){return U(z,G,X)<=0}function me(z,G,X,he){var pe;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),pe=z===X;break;case"!==":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),pe=z!==X;break;case"":case"=":case"==":pe=K(z,X,he);break;case"!=":pe=re(z,X,he);break;case">":pe=V(z,X,he);break;case">=":pe=ce(z,X,he);break;case"<":pe=H(z,X,he);break;case"<=":pe=we(z,X,he);break;default:throw new TypeError("Invalid operator: "+G)}return pe}function le(z,G){if(z instanceof le){if(z.loose===G)return z;z=z.value}if(!(this instanceof le))return new le(z,G);I("comparator",z,G),this.loose=G,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(z,G){return T(G,z)},e.major=function(z,G){return new C(z,G).major},e.minor=function(z,G){return new C(z,G).minor},e.patch=function(z,G){return new C(z,G).patch},e.compare=U,e.compareLoose=function(z,G){return U(z,G,!0)},e.rcompare=function(z,G,X){return U(G,z,X)},e.sort=function(z,G){return z.sort(function(X,he){return e.compare(X,he,G)})},e.rsort=function(z,G){return z.sort(function(X,he){return e.rcompare(X,he,G)})},e.gt=V,e.lt=H,e.eq=K,e.neq=re,e.gte=ce,e.lte=we,e.cmp=me,e.Comparator=le;var de={};function ge(z,G){if(z instanceof ge)return z.loose===G?z:new ge(z.raw,G);if(z instanceof le)return new ge(z.value,G);if(!(this instanceof ge))return new ge(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function oe(z){return!z||z.toLowerCase()==="x"||z==="*"}function ye(z,G,X,he,pe,Oe,Ie,Ae,ke,Te,Ue,Re,Le){return((G=oe(X)?"":oe(he)?">="+X+".0.0":oe(pe)?">="+X+"."+he+".0":">="+G)+" "+(Ae=oe(ke)?"":oe(Te)?"<"+(+ke+1)+".0.0":oe(Ue)?"<"+ke+"."+(+Te+1)+".0":Re?"<="+ke+"."+Te+"."+Ue+"-"+Re:"<="+Ae)).trim()}function Se(z,G){for(var X=0;X<z.length;X++)if(!z[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<z.length;X++)if(I(z[X].semver),z[X].semver!==de&&z[X].semver.prerelease.length>0){var he=z[X].semver;if(he.major===G.major&&he.minor===G.minor&&he.patch===G.patch)return!0}return!1}return!0}function Ne(z,G,X){try{G=new ge(G,X)}catch{return!1}return G.test(z)}function Fe(z,G,X,he){var pe,Oe,Ie,Ae,ke;switch(z=new C(z,he),G=new ge(G,he),X){case">":pe=V,Oe=we,Ie=H,Ae=">",ke=">=";break;case"<":pe=H,Oe=ce,Ie=V,Ae="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(z,G,he))return!1;for(var Te=0;Te<G.set.length;++Te){var Ue=G.set[Te],Re=null,Le=null;if(Ue.forEach(function(Ce){Ce.semver===de&&(Ce=new le(">=0.0.0")),Re=Re||Ce,Le=Le||Ce,pe(Ce.semver,Re.semver,he)?Re=Ce:Ie(Ce.semver,Le.semver,he)&&(Le=Ce)}),Re.operator===Ae||Re.operator===ke||(!Le.operator||Le.operator===Ae)&&Oe(z,Le.semver)||Le.operator===ke&&Ie(z,Le.semver))return!1}return!0}le.prototype.parse=function(z){var G=this.loose?w[ve]:w[B],X=z.match(G);if(!X)throw new TypeError("Invalid comparator: "+z);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new C(X[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new C(z,this.loose)),me(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,G){if(!(z instanceof le))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ge(z.value,G),Ne(this.value,X,G);if(z.operator==="")return X=new ge(this.value,G),Ne(z.semver,X,G);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ae=me(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ke=me(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||pe||Oe&&Ie||Ae||ke},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),I("range",z,G);var X=G?w[$]:w[M];z=z.replace(X,ye),I("hyphen replace",z),z=z.replace(w[j],"$1$2$3"),I("comparator trim",z,w[j]),z=(z=(z=z.replace(w[ee],"$1~")).replace(w[ae],"$1^")).split(/\s+/).join(" ");var he=G?w[ve]:w[B],pe=z.split(" ").map(function(Oe){return function(Ie,Ae){return I("comp",Ie),Ie=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){I("caret",Re,Le);var Ce=Le?w[se]:w[ue];return Re.replace(Ce,function(je,Ee,be,Pe,De){var Me;return I("caret",Re,je,Ee,be,Pe,De),oe(Ee)?Me="":oe(be)?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Pe)?Me=Ee==="0"?">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+".0 <"+(+Ee+1)+".0.0":De?(I("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=Ee==="0"?be==="0"?">="+Ee+"."+be+"."+Pe+De+" <"+Ee+"."+be+"."+(+Pe+1):">="+Ee+"."+be+"."+Pe+De+" <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+"."+Pe+De+" <"+(+Ee+1)+".0.0"):(I("no pr"),Me=Ee==="0"?be==="0"?">="+Ee+"."+be+"."+Pe+" <"+Ee+"."+be+"."+(+Pe+1):">="+Ee+"."+be+"."+Pe+" <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+"."+Pe+" <"+(+Ee+1)+".0.0"),I("caret return",Me),Me})}(Ue,Te)}).join(" ")}(Ie,Ae),I("caret",Ie),Ie=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){var Ce=Le?w[ie]:w[te];return Re.replace(Ce,function(je,Ee,be,Pe,De){var Me;return I("tilde",Re,je,Ee,be,Pe,De),oe(Ee)?Me="":oe(be)?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Pe)?Me=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0":De?(I("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=">="+Ee+"."+be+"."+Pe+De+" <"+Ee+"."+(+be+1)+".0"):Me=">="+Ee+"."+be+"."+Pe+" <"+Ee+"."+(+be+1)+".0",I("tilde return",Me),Me})}(Ue,Te)}).join(" ")}(Ie,Ae),I("tildes",Ie),Ie=function(ke,Te){return I("replaceXRanges",ke,Te),ke.split(/\s+/).map(function(Ue){return function(Re,Le){Re=Re.trim();var Ce=Le?w[A]:w[h];return Re.replace(Ce,function(je,Ee,be,Pe,De,Me){I("xRange",Re,je,Ee,be,Pe,De,Me);var We=oe(be),ze=We||oe(Pe),Be=ze||oe(De);return Ee==="="&&Be&&(Ee=""),We?je=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Pe=0),Be&&(De=0),Ee===">"?(Ee=">=",ze?(be=+be+1,Pe=0,De=0):Be&&(Pe=+Pe+1,De=0)):Ee==="<="&&(Ee="<",ze?be=+be+1:Pe=+Pe+1),je=Ee+be+"."+Pe+"."+De):ze?je=">="+be+".0.0 <"+(+be+1)+".0.0":Be&&(je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),I("xRange return",je),je})}(Ue,Te)}).join(" ")}(Ie,Ae),I("xrange",Ie),Ie=function(ke,Te){return I("replaceStars",ke,Te),ke.trim().replace(w[W],"")}(Ie,Ae),I("stars",Ie),Ie}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new le(Oe,G)})},ge.prototype.intersects=function(z,G){if(!(z instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(he){return z.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,G)})})})})},e.toComparators=function(z,G){return new ge(z,G).set.map(function(X){return X.map(function(he){return he.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new C(z,this.loose));for(var G=0;G<this.set.length;G++)if(Se(this.set[G],z))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(z,G,X){var he=null,pe=null;try{var Oe=new ge(G,X)}catch{return null}return z.forEach(function(Ie){Oe.test(Ie)&&(he&&pe.compare(Ie)!==-1||(pe=new C(he=Ie,X)))}),he},e.minSatisfying=function(z,G,X){var he=null,pe=null;try{var Oe=new ge(G,X)}catch{return null}return z.forEach(function(Ie){Oe.test(Ie)&&(he&&pe.compare(Ie)!==1||(pe=new C(he=Ie,X)))}),he},e.validRange=function(z,G){try{return new ge(z,G).range||"*"}catch{return null}},e.ltr=function(z,G,X){return Fe(z,G,"<",X)},e.gtr=function(z,G,X){return Fe(z,G,">",X)},e.outside=Fe,e.prerelease=function(z,G){var X=J(z,G);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(z,G,X){return z=new ge(z,X),G=new ge(G,X),z.intersects(G)},e.coerce=function(z){if(z instanceof C)return z;if(typeof z!="string")return null;var G=z.match(w[F]);return G==null?null:J((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,O(1))},function(x,e){var O,R,I=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function w(u){if(O===setTimeout)return setTimeout(u,0);if((O===D||!O)&&setTimeout)return O=setTimeout,setTimeout(u,0);try{return O(u,0)}catch{try{return O.call(null,u,0)}catch{return O.call(this,u,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:D}catch{O=D}try{R=typeof clearTimeout=="function"?clearTimeout:k}catch{R=k}})();var g,c=[],b=!1,p=-1;function d(){b&&g&&(b=!1,g.length?c=g.concat(c):p=-1,c.length&&P())}function P(){if(!b){var u=w(d);b=!0;for(var f=c.length;f;){for(g=c,c=[];++p<f;)g&&g[p].run();p=-1,f=c.length}g=null,b=!1,function(y){if(R===clearTimeout)return clearTimeout(y);if((R===k||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(y);try{R(y)}catch{try{return R.call(null,y)}catch{return R.call(this,y)}}}(u)}}function m(u,f){this.fun=u,this.array=f}function N(){}I.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)f[y-1]=arguments[y];c.push(new m(u,f)),c.length!==1||b||w(P)},m.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=N,I.addListener=N,I.once=N,I.off=N,I.removeListener=N,I.removeAllListeners=N,I.emit=N,I.prependListener=N,I.prependOnceListener=N,I.listeners=function(u){return[]},I.binding=function(u){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(u){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(w,g,c){this.level=w,this.key=g,this.value=c,this.forward=[]}}const I=void 0;class D{constructor(w,g=2**16){this.comparator=w,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,I,I)}get size(){return this.f}clear(){this.e=new R(this.c,I,I)}has(w){return Boolean(D.g(this,w,this.comparator))}get(w){return D.g(this,w,this.comparator)?.value}set(w,g){return D.h(this,w,g,this.comparator)&&(this.f+=1),this}delete(w){const g=D.k(this,w,this.comparator);return g&&(this.f-=1),g}forEach(w,g){let c=this.e.forward[0];for(;c;)w.call(g,c.value,c.key,this),c=c.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this.e.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this.e.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this.e.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",g=this.e.forward[0];for(;g;)w+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return w}static g(w,g,c){let b=w.e;for(let p=w.d-1;p>=0;p--)for(;b.forward[p]&&c(b.forward[p].key,g)<0;)b=b.forward[p];if(b=b.forward[0],b&&c(b.key,g)===0)return b}static h(w,g,c,b){const p=[];let d=w.e;for(let P=w.d-1;P>=0;P--){for(;d.forward[P]&&b(d.forward[P].key,g)<0;)d=d.forward[P];p[P]=d}if(d=d.forward[0],d&&b(d.key,g)===0)return d.value=c,!1;{const P=D.j(w);if(P>w.d){for(let m=w.d;m<P;m++)p[m]=w.e;w.d=P}d=new R(P,g,c);for(let m=0;m<P;m++)d.forward[m]=p[m].forward[m],p[m].forward[m]=d;return!0}}static j(w,g=.5){let c=1;for(;Math.random()<g&&c<w.c;)c+=1;return c}static k(w,g,c){const b=[];let p=w.e;for(let d=w.d-1;d>=0;d--){for(;p.forward[d]&&c(p.forward[d].key,g)<0;)p=p.forward[d];b[d]=p}if(p=p.forward[0],!p||c(p.key,g)!==0)return!1;for(let d=0;d<w.d&&b[d].forward[d]===p;d++)b[d].forward[d]=p.forward[d];for(;w.d>0&&w.e.forward[w.d-1]===I;)w.d-=1;return!0}}e.SkipList=D}),define(Z[43],Q([0,1,7,2]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(v){const E=v;return E?typeof E.read=="function":!1}e.isReadable=I;function D(v){const E=v;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function k(v){const E=v;return E?D(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=k;function w(v,E){return new g(v,E)}e.newWriteableStream=w;class g{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,O.onUnexpectedError)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let s;switch(E){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(v,E){const t=[];let s;for(;(s=v.read())!==null;)t.push(s);return E(t)}e.consumeReadable=c;function b(v,E,t){const s=[];let i;for(;(i=v.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?E(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return v.read()}}}e.peekReadable=b;function p(v,E){return new Promise((t,s)=>{const i=[];d(v,{onData:n=>{E&&i.push(n)},onError:n=>{E?s(n):t(void 0)},onEnd:()=>{t(E?E(i):void 0)}})})}e.consumeStream=p;function d(v,E){let t=!1;return v.on("error",s=>{t||E.onError(s)}),v.on("end",()=>{t||E.onEnd()}),v.on("data",s=>{t||E.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=d;function P(v,E){return new Promise((t,s)=>{const i=new R.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>E)return i.dispose(),v.pause(),t({stream:v,buffer:n,ended:!1})},o=l=>s(l),a=()=>t({stream:v,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),i.add((0,R.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),i.add((0,R.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=P;function m(v,E){const t=w(E);return t.end(v),t}e.toStream=m;function N(){const v=w(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=N;function u(v){let E=!1;return{read:()=>E?null:(E=!0,v)}}e.toReadable=u;function f(v,E,t){const s=w(t);return d(v,{onData:i=>s.write(E.data(i)),onError:i=>s.error(E.error?E.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function y(v,E,t){let s=!1;return{read:()=>{const i=E.read();return s?i:(s=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=y;function S(v,E,t){let s=!1;const i=w(t);return d(E,{onData:n=>s?i.write(n):(s=!0,i.write(t([v,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(v)),i.end()}}),i}e.prefixedStream=S}),define(Z[15],Q([0,1,43]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let I,D;class k{static alloc(l){return R?new k(Buffer.allocUnsafe(l)):new k(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new k(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&R?new k(Buffer.from(l)):(I||(I=new TextEncoder),new k(I.encode(l)))}static fromByteArray(l){const h=k.alloc(l.length);for(let A=0,F=l.length;A<F;A++)h.buffer[A]=l[A];return h}static concat(l,h){if(typeof h>"u"){h=0;for(let Y=0,ee=l.length;Y<ee;Y++)h+=l[Y].byteLength}const A=k.alloc(h);let F=0;for(let Y=0,ee=l.length;Y<ee;Y++){const te=l[Y];A.set(te,F),F+=te.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=k.alloc(this.byteLength);return l.set(this),l}toString(){return R?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(l,h){return new k(this.buffer.subarray(l,h))}set(l,h){if(l instanceof k)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return c(this.buffer,l)}writeUInt32BE(l,h){b(this.buffer,l,h)}readUInt32LE(l){return p(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,h){m(this.buffer,l,h)}}e.VSBuffer=k;function w(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=w;function g(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255}e.writeUInt16LE=g;function c(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=c;function b(a,l,h){a[h+3]=l,l=l>>>8,a[h+2]=l,l=l>>>8,a[h+1]=l,l=l>>>8,a[h]=l}e.writeUInt32BE=b;function p(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=p;function d(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255,l=l>>>8,a[h+2]=l&255,l=l>>>8,a[h+3]=l&255}e.writeUInt32LE=d;function P(a,l){return a[l]}e.readUInt8=P;function m(a,l,h){a[h]=l}e.writeUInt8=m;function N(a){return O.consumeReadable(a,l=>k.concat(l))}e.readableToBuffer=N;function u(a){return O.toReadable(a)}e.bufferToReadable=u;function f(a){return O.consumeStream(a,l=>k.concat(l))}e.streamToBuffer=f;async function y(a){return a.ended?k.concat(a.buffer):k.concat([...a.buffer,await f(a.stream)])}e.bufferedStreamToBuffer=y;function S(a){return O.toStream(a,l=>k.concat(l))}e.bufferToStream=S;function v(a){return O.transform(a,{data:l=>typeof l=="string"?k.fromString(l):k.wrap(l)},l=>k.concat(l))}e.streamToBufferReadableStream=v;function E(a){return O.newWriteableStream(l=>k.concat(l),a)}e.newWriteableBufferStream=E;function t(a,l){return O.prefixedReadable(a,l,h=>k.concat(h))}e.prefixedBufferReadable=t;function s(a,l){return O.prefixedStream(a,l,h=>k.concat(h))}e.prefixedBufferStream=s;function i(a){let l=0,h=0,A=0;const F=new Uint8Array(Math.floor(a.length/4*3)),Y=te=>{switch(h){case 3:F[A++]=l|te,h=0;break;case 2:F[A++]=l|te>>>2,l=te<<6,h=3;break;case 1:F[A++]=l|te>>>4,l=te<<4,h=2;break;default:l=te<<2,h=1}};for(let te=0;te<a.length;te++){const ie=a.charCodeAt(te);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[te]}`)}}const ee=A;for(;h>0;)Y(0);return k.wrap(F).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},l=!0,h=!1){const A=h?r:n;let F="";const Y=a.byteLength%3;let ee=0;for(;ee<a.byteLength-Y;ee+=3){const te=a[ee+0],ie=a[ee+1],ne=a[ee+2];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[(ie<<2|ne>>>6)&63],F+=A[ne&63]}if(Y===1){const te=a[ee+0];F+=A[te>>>2],F+=A[te<<4&63],l&&(F+="==")}else if(Y===2){const te=a[ee+0],ie=a[ee+1];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[ie<<2&63],l&&(F+="=")}return F}e.encodeBase64=o}),define(Z[30],Q([0,1,3]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([S,v])=>{y[S]=v&&typeof v=="object"?R(v):v}),y}e.deepClone=R;function I(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const S=y.shift();Object.freeze(S);for(const v in S)if(D.call(S,v)){const E=S[v];typeof E=="object"&&!Object.isFrozen(E)&&!(0,O.isTypedArray)(E)&&y.push(E)}}return f}e.deepFreeze=I;const D=Object.prototype.hasOwnProperty;function k(f,y){return w(f,y,new Set)}e.cloneAndChange=k;function w(f,y,S){if((0,O.isUndefinedOrNull)(f))return f;const v=y(f);if(typeof v<"u")return v;if(Array.isArray(f)){const E=[];for(const t of f)E.push(w(t,y,S));return E}if((0,O.isObject)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const E={};for(const t in f)D.call(f,t)&&(E[t]=w(f[t],y,S));return S.delete(f),E}return f}function g(f,y,S=!0){return(0,O.isObject)(f)?((0,O.isObject)(y)&&Object.keys(y).forEach(v=>{v in f?S&&((0,O.isObject)(f[v])&&(0,O.isObject)(y[v])?g(f[v],y[v],S):f[v]=y[v]):f[v]=y[v]}),f):y}e.mixin=g;function c(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let S,v;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(S=0;S<f.length;S++)if(!c(f[S],y[S]))return!1}else{const E=[];for(v in f)E.push(v);E.sort();const t=[];for(v in y)t.push(v);if(t.sort(),!c(E,t))return!1;for(S=0;S<E.length;S++)if(!c(f[E[S]],y[E[S]]))return!1}return!0}e.equals=c;function b(f){const y=new Set;return JSON.stringify(f,(S,v)=>{if((0,O.isObject)(v)||Array.isArray(v)){if(y.has(v))return"[Circular]";y.add(v)}return v})}e.safeStringify=b;function p(f,y){const S=Object.create(null);return!f||!y||Object.keys(y).forEach(E=>{const t=f[E],s=y[E];c(t,s)||(S[E]=s)}),S}e.distinct=p;function d(f,y){const S=y.toLowerCase(),v=Object.keys(f).find(E=>E.toLowerCase()===S);return v?f[v]:f[y]}e.getCaseInsensitive=d;function P(f,y){const S=Object.create(null);for(const[v,E]of Object.entries(f))y(v,E)&&(S[v]=E);return S}e.filter=P;function m(f){let y=[],S=Object.getPrototypeOf(f);for(;Object.prototype!==S;)y=y.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return y}e.getAllPropertyNames=m;function N(f){const y=[];for(const S of m(f))typeof f[S]=="function"&&y.push(S);return y}e.getAllMethodNames=N;function u(f,y){const S=E=>function(){const t=Array.prototype.slice.call(arguments,0);return y(E,t)},v={};for(const E of f)v[E]=S(E);return v}e.createProxyObject=u}),define(Z[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(I){return O.test(I)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(w){for(let g=0;g<w.length;g++)w[g]=Math.floor(Math.random()*256);return w};const D=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));return function(){I(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let g=0,c="";return c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c}}()}),define(Z[73],Q([0,1,33]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(k){const w=k.replace(/\-/g,":").toLowerCase();return!R.has(w)}function D(){const k=(0,O.networkInterfaces)();for(const w in k){const g=k[w];if(g){for(const{mac:c}of g)if(I(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[74],Q([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,I=R*60,D=I*24,k=D*7,w=D*30,g=D*365;function c(p,d,P,m){typeof p!="number"&&(p=p.getTime());const N=Math.round((new Date().getTime()-p)/1e3);if(N<-30)return(0,O.localize)(0,null,c(new Date().getTime()+N*1e3,!1));if(!m&&N<30)return(0,O.localize)(1,null);let u;return N<R?(u=N,d?u===1?P?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):P?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u):u===1?P?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):P?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):N<I?(u=Math.floor(N/R),d?u===1?P?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):P?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u):u===1?P?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):P?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):N<D?(u=Math.floor(N/I),d?u===1?P?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):P?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u):u===1?P?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):P?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):N<k?(u=Math.floor(N/D),d?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u)):N<w?(u=Math.floor(N/k),d?u===1?P?(0,O.localize)(30,null,u):(0,O.localize)(31,null,u):P?(0,O.localize)(32,null,u):(0,O.localize)(33,null,u):u===1?P?(0,O.localize)(34,null,u):(0,O.localize)(35,null,u):P?(0,O.localize)(36,null,u):(0,O.localize)(37,null,u)):N<g?(u=Math.floor(N/w),d?u===1?P?(0,O.localize)(38,null,u):(0,O.localize)(39,null,u):P?(0,O.localize)(40,null,u):(0,O.localize)(41,null,u):u===1?P?(0,O.localize)(42,null,u):(0,O.localize)(43,null,u):P?(0,O.localize)(44,null,u):(0,O.localize)(45,null,u)):(u=Math.floor(N/g),d?u===1?P?(0,O.localize)(46,null,u):(0,O.localize)(47,null,u):P?(0,O.localize)(48,null,u):(0,O.localize)(49,null,u):u===1?P?(0,O.localize)(50,null,u):(0,O.localize)(51,null,u):P?(0,O.localize)(52,null,u):(0,O.localize)(53,null,u))}e.fromNow=c;function b(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Z[76],Q([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,3,76]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(p,d){return d&&(p.stack||p.stacktrace)?I.localize(0,null,w(p),k(p.stack)||k(p.stacktrace)):w(p)}function k(p){return Array.isArray(p)?p.join(`
`):p}function w(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?I.localize(1,null,p.message):p.message||I.localize(2,null)}function g(p=null,d=!1){if(!p)return I.localize(3,null);if(Array.isArray(p)){const P=O.coalesce(p),m=g(P[0],d);return P.length>1?I.localize(4,null,m,P.length):m}if(R.isString(p))return p;if(p.detail){const P=p.detail;if(P.error)return D(P.error,d);if(P.exception)return D(P.exception,d)}return p.stack?D(p,d):p.message?p.message:I.localize(5,null)}e.toErrorMessage=g;function c(p){const d=p;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=c;function b(p,d){let P;return typeof p=="string"?P=new Error(p):P=p,P.actions=d,P}e.createErrorWithActions=b}),define(Z[77],Q([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(I){switch(I){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Z[50],Q([0,1,12]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var I;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(w,...g){const c=g.reduce((d,P)=>(d[P]=!0,d),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(d=>!c[d]).forEach(d=>{for(let P=0;P<b.length;P++)if(d.search(b[P])!==-1){delete w[d];break}})}e.sanitizeProcessEnvironment=D;function k(w){!w||(delete w.DEBUG,O.isMacintosh&&delete w.DYLD_LIBRARY_PATH,O.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(Z[51],Q([0,1,32]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return I(f,0)}e.hash=R;function I(f,y){switch(typeof f){case"object":return f===null?D(349,y):Array.isArray(f)?g(f,y):c(f,y);case"string":return w(f,y);case"boolean":return k(f,y);case"number":return D(f,y);case"undefined":return D(937,y);default:return D(617,y)}}e.doHash=I;function D(f,y){return(y<<5)-y+f|0}e.numberHash=D;function k(f,y){return D(f?433:863,y)}function w(f,y){y=D(149417,y);for(let S=0,v=f.length;S<v;S++)y=D(f.charCodeAt(S),y);return y}e.stringHash=w;function g(f,y){return y=D(104579,y),f.reduce((S,v)=>I(v,S),y)}function c(f,y){return y=D(181387,y),Object.keys(f).sort().reduce((S,v)=>(S=w(v,S),I(f[v],S)),y)}class b{constructor(){this.g=0}get value(){return this.g}hash(y){return this.g=I(y,this.g),this.g}}e.Hasher=b;var p;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function d(f,y,S=32){const v=S-y,E=~((1<<v)-1);return(f<<y|(E&f)>>>v)>>>0}function P(f,y=0,S=f.byteLength,v=0){for(let E=0;E<S;E++)f[y+E]=v}function m(f,y,S="0"){for(;f.length<y;)f=S+f;return f}function N(f,y=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(S=>S.toString(16).padStart(2,"0")).join(""):m((f>>>0).toString(16),y/4)}e.toHexString=N;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const S=y.length;if(S===0)return;const v=this.p;let E=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=y.charCodeAt(0),i=0);;){let n=s;if(O.isHighSurrogate(s))if(i+1<S){const r=y.charCodeAt(i+1);O.isLowSurrogate(r)?(i++,n=O.computeCodePoint(s,r)):n=65533}else{t=s;break}else O.isLowSurrogate(s)&&(n=65533);if(E=this.w(v,E,n),i++,i<S)s=y.charCodeAt(i);else break}this.r=E,this.u=t}w(y,S,v){return v<128?y[S++]=v:v<2048?(y[S++]=192|(v&1984)>>>6,y[S++]=128|(v&63)>>>0):v<65536?(y[S++]=224|(v&61440)>>>12,y[S++]=128|(v&4032)>>>6,y[S++]=128|(v&63)>>>0):(y[S++]=240|(v&1835008)>>>18,y[S++]=128|(v&258048)>>>12,y[S++]=128|(v&4032)>>>6,y[S++]=128|(v&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=u.g,S=this.q;for(let a=0;a<64;a+=4)y.setUint32(a,S.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,d(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let v=this.h,E=this.l,t=this.m,s=this.n,i=this.o,n,r,o;for(let a=0;a<80;a++)a<20?(n=E&t|~E&s,r=1518500249):a<40?(n=E^t^s,r=1859775393):a<60?(n=E&t|E&s|t&s,r=2400959708):(n=E^t^s,r=3395469782),o=d(v,5)+n+i+r+y.getUint32(a*4,!1)&4294967295,i=s,s=t,t=d(E,30),E=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(Z[52],Q([0,1,32]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const D="error",k="warning",w="warn",g="info",c="ignore";function b(d){return d?O.equalsIgnoreCase(D,d)?I.Error:O.equalsIgnoreCase(k,d)||O.equalsIgnoreCase(w,d)?I.Warning:O.equalsIgnoreCase(g,d)?I.Info:I.Ignore:I.Ignore}I.fromValue=b;function p(d){switch(d){case I.Error:return D;case I.Warning:return k;case I.Info:return g;default:return c}}I.toString=p}(R||(R={})),e.default=R}),define(Z[79],Q([0,1,11]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=R;function I(c){const b=[];let p;try{const d=JSON.parse(c.arguments),P=d[d.length-1];P&&P.__$stack&&(d.pop(),p=P.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:p}}e.parse=I;function D(c){if(typeof c!="string")return D(I(c).stack);const b=c;if(b){const p=k(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=D;function k(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function w(c,b){const{args:p,stack:d}=I(c),P=typeof p[0]=="string"&&p.length===1;let m=k(d);m&&(m=`(${m.trim()})`);let N=[];if(typeof p[0]=="string"?m&&P?N=[`%c[${b}] %c${p[0]} %c${m}`,g("blue"),g(""),g("grey")]:N=[`%c[${b}] %c${p[0]}`,g("blue"),g(""),...p.slice(1)]:N=[`%c[${b}]%`,g("blue"),...p],m&&!P&&N.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,N)}e.log=w;function g(c){return`color: ${c}`}}),define(Z[53],Q([0,1,15,32,11]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(c){return JSON.stringify(c,w)}e.stringify=D;function k(c){let b=JSON.parse(c);return b=g(b),b}e.parse=k;function w(c,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,R.regExpFlags)(b)}:b}function g(c,b=0){if(!c||b>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return I.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof O.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let p=0;p<c.length;++p)c[p]=g(c[p],b+1);else for(const p in c)Object.hasOwnProperty.call(c,p)&&(c[p]=g(c[p],b+1))}return c}e.revive=g}),define(Z[80],Q([0,1,33,7,54,31,73]),function(x,e,O,R,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=I.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,p=0;const d=(0,O.networkInterfaces)();for(const P in d){const m=d[P];if(m)for(const{mac:N,internal:u}of m)u||(p+=1,this.c(N.toUpperCase())&&(b+=1))}this.b=p>0?b/p:0}return this.b}};let w;async function g(){return w||(w=(async()=>await c()||D.generateUuid())()),w}e.getMachineId=g;async function c(){try{const b=await new Promise((d,P)=>{x(["crypto"],d,P)}),p=(0,k.getMac)();return b.createHash("sha256").update(p,"utf8").digest("hex")}catch(b){R.onUnexpectedError(b);return}}}),define(Z[81],Q([0,1,33,14,20]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class p{constructor(E,t,s){this.exePath=E,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:v=!1}={}){return v?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:v=!1,findPreview:E=!1}={}){const t=d({useAlternateBitness:v});if(!t)return null;const s=R.join(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const a of await I.Promises.readdir(s)){let l=-1;if(E){const A=a.indexOf("-");if(A<0)continue;const F=a.substring(0,A);if(!D.test(F)||a.substring(A+1)!=="preview")continue;l=parseInt(F,10)}else{if(!D.test(a))continue;l=parseInt(a,10)}if(l<=i)continue;const h=R.join(s,a,"pwsh.exe");!await I.SymlinkSupport.existsFile(h)||(n=h,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=E?" Preview":"";return new p(n,`PowerShell${o}${r}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const E=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=v?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await I.Promises.readdir(E))if(t.test(i)){const n=R.join(E,i,"pwsh.exe");return new p(n,s)}return null}function N(){const v=R.join(O.homedir(),".dotnet","tools","pwsh.exe");return new p(v,".NET Core PowerShell Global Tool")}function u(){const v=R.join(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(v,"Windows PowerShell",!0)}async function*f(){let v=await P();v&&(yield v),v=await P({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=N(),v&&(yield v),v=await P({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await P({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=u(),v&&(yield v)}async function*y(){for await(const v of f())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=y;async function S(){for await(const v of y())return v;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Z[55],Q([0,1,14,12,35,50,3,20]),function(x,e,O,R,I,D,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function g(p=I.env){return p.comspec||"cmd.exe"}e.getWindowsShell=g;function c(p){let d=[],P=!1;const m=function(N){if(P){d.push(N);return}(!p.send(N,f=>{if(f&&console.error(f),P=!1,d.length>0){const y=d.slice(0);d=[],y.forEach(S=>m(S))}})||R.isWindows)&&(P=!0)};return{send:m}}e.createQueuedSender=c;var b;(function(p){async function d(P,m,N){if(O.isAbsolute(P))return P;if(m===void 0&&(m=I.cwd()),O.dirname(P)!=="."||(N===void 0&&k.isString(I.env.PATH)&&(N=I.env.PATH.split(O.delimiter)),N===void 0||N.length===0))return O.join(m,P);async function f(y){if(await w.Promises.exists(y)){let S;try{S=await w.Promises.stat(y)}catch(v){v.message.startsWith("EACCES")&&(S=await w.Promises.lstat(y))}return S?!S.isDirectory():!1}return!1}for(const y of N){let S;if(O.isAbsolute(y)?S=O.join(y,P):S=O.join(m,y,P),await f(S))return S;let v=S+".com";if(await f(v)||(v=S+".exe",await f(v)))return v}return O.join(m,P)}p.findExecutable=d})(b=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(p,d){return p===1?R.isWindows?b():D.getWindowsShell(d):g(p,d)}e.getSystemShell=k;let w=null;function g(p,d){if(R.isLinux&&p===2||R.isMacintosh&&p===3)return"/bin/bash";if(!w){let P;if(R.isWindows)P="/bin/bash";else{if(P=d.SHELL,!P)try{P=(0,O.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}w=P}return w}let c=null;async function b(){return c||(c=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),c}});var fe=this&&this.__decorate||function(x,e,O,R){var I=arguments.length,D=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,O):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,O,R);else for(var w=x.length-1;w>=0;w--)(k=x[w])&&(D=(I<3?k(D):I>3?k(e,O,D):k(e,O))||D);return I>3&&D&&Object.defineProperty(e,O,D),D};define(Z[56],Q([0,1,19,5,15,22,48,7,4,2,53,32,3]),function(x,e,O,R,I,D,k,w,g,c,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var P;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(P||(P={}));function m(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var N;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(N||(N={}));function u(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));function y(j){let M=0;for(let $=0;;$+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<$,!(W.buffer[0]&128))return M}}const S=i(0);function v(j,M){if(M===0){j.write(S);return}let $=0;for(let q=M;q!==0;q=q>>>7)$++;const W=I.VSBuffer.alloc($);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class E{constructor(M){this.b=M,this.a=0}read(M){const $=this.b.slice(this.a,this.a+M);return this.a+=$.byteLength,$}}e.BufferReader=E;class t{constructor(){this.a=[]}get buffer(){return I.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=I.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function o(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const $=I.VSBuffer.fromString(M);j.write(n.String),v(j,$.byteLength),j.write($)}else if(r&&Buffer.isBuffer(M)){const $=I.VSBuffer.wrap(M);j.write(n.Buffer),v(j,$.byteLength),j.write($)}else if(M instanceof I.VSBuffer)j.write(n.VSBuffer),v(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),v(j,M.length);for(const $ of M)o(j,$)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),v(j,M);else{const $=I.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),v(j,$.byteLength),j.write($)}}e.serialize=o;function a(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(y(j)).toString();case s.Buffer:return j.read(y(j)).buffer;case s.VSBuffer:return j.read(y(j));case s.Array:{const $=y(j),W=[];for(let q=0;q<$;q++)W.push(a(j));return W}case s.Object:return JSON.parse(j.read(y(j)).toString());case s.Int:return y(j)}}e.deserialize=a;class l{constructor(M,$,W=null,q=1e3){this.h=M,this.j=$,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(M,$){this.b.set(M,$),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const $=this.o([M.type]);this.k?.logOutgoing($,0,1,u(M.type));return}case 201:case 202:case 204:case 203:{const $=this.o([M.type,M.id],M.data);this.k?.logOutgoing($,M.id,1,u(M.type),M.data);return}}}o(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const $=new E(M),W=a($),q=a($),J=W[0];switch(J){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${m(J)}: ${W[2]}.${W[3]}`,q),this.s({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${m(J)}: ${W[2]}.${W[3]}`,q),this.t({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${m(J)}`),this.u({type:J,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${m(J)}`),this.u({type:J,id:W[1]})}}s(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=new D.CancellationTokenSource;let q;try{q=$.call(this.j,M.name,M.arg,W.token)}catch(L){q=Promise.reject(L)}const J=M.id;q.then(L=>{this.m({id:J,data:L,type:201}),this.d.delete(M.id)},L=>{L instanceof Error?this.m({id:J,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:J,data:L,type:203}),this.d.delete(M.id)});const C=(0,c.toDisposable)(()=>W.cancel());this.d.set(M.id,C)}t(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=M.id,J=$.listen(this.j,M.name,M.arg)(C=>this.m({id:W,data:C,type:204}));this.d.set(M.id,J)}u(M){const $=this.d.get(M.id);$&&($.dispose(),this.d.delete(M.id))}v(M){let $=this.g.get(M.channelName);$||($=[],this.g.set(M.channelName,$));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:M,timeoutTimer:W})}w(M){const $=this.g.get(M);if($){for(const W of $)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var h;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(M,$=null){this.l=M,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=$}getChannel(M){const $=this;return{call(W,q,J){return $.a?Promise.reject(new w.CancellationError):$.m(M,W,q,J)},listen(W,q){return $.a?g.Event.None:$.o(M,W,q)}}}m(M,$,W,q=D.CancellationToken.None){const J=this.g++,L={id:J,type:100,channelName:M,name:$,arg:W};if(q.isCancellationRequested)return Promise.reject(new w.CancellationError);let T;return new Promise((V,H)=>{if(q.isCancellationRequested)return H(new w.CancellationError);const K=()=>{const me=le=>{switch(le.type){case 201:this.f.delete(J),V(le.data);break;case 202:{this.f.delete(J);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,H(de);break}case 203:this.f.delete(J),H(le.data);break}};this.f.set(J,me),this.p(L)};let re=null;this.b===f.Idle?K():(re=(0,R.createCancelablePromise)(me=>this.u()),re.then(()=>{re=null,K()}));const ce=()=>{re?(re.cancel(),re=null):this.p({id:J,type:101}),H(new w.CancellationError)},we=q.onCancellationRequested(ce);T=(0,c.combinedDisposable)((0,c.toDisposable)(ce),we),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(M,$,W){const q=this.g++,C={id:q,type:102,channelName:M,name:$,arg:W};let L=null;const T=new g.Emitter({onWillAddFirstListener:()=>{L=(0,R.createCancelablePromise)(V=>this.u()),L.then(()=>{L=null,this.d.add(T),this.p(C)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(T),this.p({id:q,type:103}))}}),U=V=>T.fire(V.data);return this.f.set(q,U),T.event}p(M){switch(M.type){case 100:case 102:{const $=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing($,M.id,0,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.q([M.type,M.id]);this.j?.logOutgoing($,M.id,0,m(M.type));return}}}q(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const $=new E(M),W=a($),q=a($),J=W[0];switch(J){case 200:return this.j?.logIncoming(M.byteLength,0,0,u(J)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,u(J),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}fe([k.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class F{get connections(){const M=[];return this.f.forEach($=>M.push($)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:$,onDidClientDisconnect:W})=>{g.Event.once($.onMessage)(J=>{const C=new E(J),L=a(C),T=new l($,L),U=new A($);this.a.forEach((H,K)=>T.registerChannel(K,H));const V={channelServer:T,channelClient:U,ctx:L};this.f.add(V),this.g.fire(V),W(()=>{T.dispose(),U.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(M,$){const W=this;return{call(q,J,C){let L;if((0,d.isFunction)($)){const U=(0,O.getRandomElement)(W.connections.filter($));L=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,$))}else L=$.routeCall(W,q,J);const T=L.then(U=>U.channelClient.getChannel(M));return ee(T).call(q,J,C)},listen(q,J){if((0,d.isFunction)($))return W.j(M,$,q,J);const C=$.routeEvent(W,q,J).then(L=>L.channelClient.getChannel(M));return ee(C).listen(q,J)}}}j(M,$,W,q){const J=this;let C=new c.DisposableStore;const L=new g.Emitter({onWillAddFirstListener:()=>{C=new c.DisposableStore;const T=new g.EventMultiplexer,U=new Map,V=K=>{const ce=K.channelClient.getChannel(M).listen(W,q),we=T.add(ce);U.set(K,we)},H=K=>{const re=U.get(K);!re||(re.dispose(),U.delete(K))};J.connections.filter($).forEach(V),g.Event.filter(J.onDidAddConnection,$)(V,void 0,C),J.onDidRemoveConnection(H,void 0,C),T.event(L.fire,L,C),C.add(T)},onDidRemoveLastListener:()=>{C.dispose()}});return L.event}registerChannel(M,$){this.a.set(M,$),this.f.forEach(W=>{W.channelServer.registerChannel(M,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Y{constructor(M,$,W=null){const q=new t;o(q,$),M.send(q.buffer),this.a=new A(M,W),this.d=new l(M,$,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,$){this.d.registerChannel(M,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function ee(j){return{call(M,$,W){return j.then(q=>q.call(M,$,W))},listen(M,$){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,$)),W.event}}}e.getDelayedChannel=ee;function te(j){let M=!1;return{call($,W,q){return M?j.call($,W,q):(0,R.timeout)(0).then(()=>M=!0).then(()=>j.call($,W,q))},listen($,W){if(M)return j.listen($,W);const q=new g.Relay;return(0,R.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen($,W)),q.event}}}e.getNextTickChannel=te;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const $ of M.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(J,C){const L=J,T=C&&C.disableMarshalling,U=new Map;for(const V in L)W(V)&&U.set(V,g.Event.buffer(L[V],!0));return new class{listen(V,H,K){const re=U.get(H);if(re)return re;if(q(H)){const ce=L[H];if(typeof ce=="function")return ce.call(L,K)}throw new Error(`Event not found: ${H}`)}call(V,H,K){const re=L[H];if(typeof re=="function"){if(!T&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,b.revive)(K[ce]);return re.apply(L,K)}throw new Error(`Method not found: ${H}`)}}}j.fromService=M;function $(J,C){const L=C&&C.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):q(U)?function(V){return J.listen(U,V)}:W(U)?J.listen(U):async function(...V){let H;C&&!(0,d.isUndefinedOrNull)(C.context)?H=[C.context,...V]:H=V;const K=await J.call(U,H);return L?K:(0,b.revive)(K)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=$;function W(J){return J[0]==="o"&&J[1]==="n"&&p.isUpperAsciiLetter(J.charCodeAt(2))}function q(J){return/^onDynamic/.test(J)&&p.isUpperAsciiLetter(J.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function se(j){return Array.isArray(j)?j.map(ue):ue(j)}function ve(j,M,$,W,q,J,C){C=se(C);const L=ae[q],T=L[W%L.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(J)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class B{constructor(M,$){this.d=M,this.f=$,this.a=0,this.b=0}logOutgoing(M,$,W,q,J){this.b+=M,ve(this.d,this.b,M,$,W,q,J)}logIncoming(M,$,W,q,J){this.a+=M,ve(this.f,this.a,M,$,W,q,J)}}e.IPCLogger=B}),define(Z[83],Q([0,1,57,5,15,22,79,7,4,2,30,55,50,56]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends P.ChannelServer{constructor(f){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",y=>I.VSBuffer.wrap(Buffer.from(y,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=m;class N{constructor(f,y){this.i=f,this.j=y,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const S=y&&y.timeout?y.timeout:6e4;this.b=new R.Delayer(S),this.d=null,this.f=null}getChannel(f){const y=this;return{call(S,v,E){return y.k(f,S,v,E)},listen(S,v){return y.l(f,S,v)}}}k(f,y,S,v=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(w.canceled());this.b.cancel();const E=this.n(f),t=(0,R.createCancelablePromise)(n=>E.call(y,S,n)),s=v.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,y,S){if(!this.b)return g.Event.None;this.b.cancel();let v;const E=new g.Emitter({onWillAddFirstListener:()=>{v=this.n(f).listen(y,S)(E.fire,E),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],y=Object.create(null);y.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(y.env={...y.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(y.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(y.env),this.d=(0,O.fork)(this.i,f,y);const S=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.j.serverName}`);return}S.fire(I.VSBuffer.wrap(Buffer.from(r,"base64")))});const E=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&E.send(r.buffer.toString("base64")),s=S.event,i={send:t,onMessage:s};this.f=new P.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,c.dispose)(a)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let y=this.g.get(f);return y||(y=this.m.getChannel(f),this.g.set(f,y)),y}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=N}),define(Z[84],Q([0,1,5,4,2,3]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function w(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=w;var g;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class c extends I.Disposable{constructor(d,P=Object.create(null)){super(),this.m=d,this.n=P,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new O.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((P,m)=>this.s(m,P)),d.deleted?.forEach(P=>this.s(P,void 0))}s(d,P){if(this.c===g.Closed)return;let m=!1;(0,D.isUndefinedOrNull)(P)?m=this.f.delete(d):this.f.get(d)!==P&&(this.f.set(d,P),m=!0),m&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,P){const m=this.f.get(d);return(0,D.isUndefinedOrNull)(m)?P:m}getBoolean(d,P){const m=this.get(d);return(0,D.isUndefinedOrNull)(m)?P:m==="true"}getNumber(d,P){const m=this.get(d);return(0,D.isUndefinedOrNull)(m)?P:parseInt(m,10)}async set(d,P){if(this.c===g.Closed)return;if((0,D.isUndefinedOrNull)(P))return this.delete(d);const m=String(P);if(this.f.get(d)!==m)return this.f.set(d,m),this.j.set(d,m),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===g.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(!!this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(!!this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===k.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((P,m)=>this.a.set(m,P)),d.delete?.forEach(P=>this.a.delete(P))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[85],Q([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,48,16,14,35,18,11]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,D.dirname)(I.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(g.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=k.env.VSCODE_PORTABLE;return m?g.URI.file((0,D.join)(m,"argv.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(I.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?g.URI.file((0,D.resolve)(m)):g.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const N=k.env.VSCODE_EXTENSIONS;if(N)return N;const u=k.env.VSCODE_PORTABLE;return u?(0,D.join)(u,"extensions"):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(N=>/^[^:/?#]+?:\/\//.test(N)?g.URI.parse(N):g.URI.file((0,D.normalize)(N)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const N of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(N);u&&u[1]&&u[2]&&m.push([u[1],u[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=k.env.VSCODE_PORTABLE;return m?g.URI.file((0,D.join)(m,"policy.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,N,u){this.a=m,this.b=N,this.c=u,this.editSessionId=this.args.editSessionId}}fe([R.memoize],c.prototype,"appRoot",null),fe([R.memoize],c.prototype,"userHome",null),fe([R.memoize],c.prototype,"userDataPath",null),fe([R.memoize],c.prototype,"appSettingsHome",null),fe([R.memoize],c.prototype,"tmpDir",null),fe([R.memoize],c.prototype,"cacheHome",null),fe([R.memoize],c.prototype,"stateResource",null),fe([R.memoize],c.prototype,"userRoamingDataHome",null),fe([R.memoize],c.prototype,"userDataSyncHome",null),fe([R.memoize],c.prototype,"userDataSyncLogResource",null),fe([R.memoize],c.prototype,"editSessionsLogResource",null),fe([R.memoize],c.prototype,"sync",null),fe([R.memoize],c.prototype,"machineSettingsResource",null),fe([R.memoize],c.prototype,"workspaceStorageHome",null),fe([R.memoize],c.prototype,"localHistoryHome",null),fe([R.memoize],c.prototype,"keyboardLayoutResource",null),fe([R.memoize],c.prototype,"argvResource",null),fe([R.memoize],c.prototype,"isExtensionDevelopment",null),fe([R.memoize],c.prototype,"untitledWorkspacesHome",null),fe([R.memoize],c.prototype,"installSourcePath",null),fe([R.memoize],c.prototype,"builtinExtensionsPath",null),fe([R.memoize],c.prototype,"extensionsPath",null),fe([R.memoize],c.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],c.prototype,"extensionDevelopmentKind",null),fe([R.memoize],c.prototype,"extensionTestsLocationURI",null),fe([R.memoize],c.prototype,"debugExtensionHost",null),fe([R.memoize],c.prototype,"logLevel",null),fe([R.memoize],c.prototype,"extensionLogLevel",null),fe([R.memoize],c.prototype,"serviceMachineIdResource",null),fe([R.memoize],c.prototype,"telemetryLogResource",null),fe([R.memoize],c.prototype,"disableWorkspaceTrust",null),fe([R.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function b(P,m){return d(P["inspect-extensions"],P["inspect-brk-extensions"],5870,m,P.debugId,P.extensionEnvironment)}e.parseExtensionHostPort=b;function p(P,m){return d(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,m,P.extensionEnvironment)}e.parsePtyHostPort=p;function d(P,m,N,u,f,y){const v=Number(m||P)||(u?null:N),E=v?Boolean(!!m):!1;let t;if(y)try{t=JSON.parse(y)}catch{}return{port:v,break:E,debugId:f,env:t}}}),function(){"use strict";function x(e,O,R){function I(k,w){const g=D(k,w),c=[g];return e.isAbsolute(g)||c.unshift(R),e.resolve(...c)}function D(k,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,w);const b=k["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(O.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,w)}return{getUserDataPath:I}}if(typeof define=="function")define(Z[105],Q([157,33,35]),function(e,O,R){return x(e,O,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=x(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends R.AbstractNativeEnvironmentService{constructor(w,g){super(w,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,I.getUserDataPath)(w,g.nameShort)},g)}}e.NativeEnvironmentService=D}),define(Z[107],Q([0,1,3,90]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function I(k,w,g){try{D(k,w,g)}catch(c){console.error(c?.message??c)}return k}e.localizeManifest=I;function D(k,w,g){const c=(b,p,d)=>{const P=b[p];if((0,O.isString)(P)){const m=P,N=m.length;if(N>1&&m[0]==="%"&&m[N-1]==="%"){const u=m.substr(1,N-2);let f=w[u];f===void 0&&g&&(f=g[u]);const y=typeof f=="string"?f:f?.message,S=g?.[u],v=typeof S=="string"?S:S?.message;if(!y){v||console.warn(`[${k.name}]: ${(0,R.localize)(0,null,u)}`);return}if(d&&(p==="title"||p==="category")&&v&&v!==y){const E={value:y,original:v};b[p]=E}else b[p]=y}}else if((0,O.isObject)(P))for(const m in P)P.hasOwnProperty(m)&&(m==="commands"?c(P,m,!0):c(P,m,d));else if(Array.isArray(P))for(let m=0;m<P.length;m++)c(P,m,d)};for(const b in k)k.hasOwnProperty(b)&&c(k,b)}}),define(Z[108],Q([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(D,k){this.a.set(D,k)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const k in D.contributes){const w=this.a.get(k);if(!w)continue;const g=D.contributes[k],c=Array.isArray(g)?g:[g];try{w(c,D.activationEvents)}catch(b){(0,O.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Z[44],Q([0,1,18,52,94,41]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=g;function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=f.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=c;function b(f){if(!f)return null;const y=f.majorBase,S=f.majorMustEqual,v=f.minorBase;let E=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(y===0||(E=!1),s=!1);let i=0;if(f.preRelease){const n=w.exec(f.preRelease);if(n){const[,r,o,a]=n;i=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:y,majorMustEqual:S,minorBase:v,minorMustEqual:E,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function p(f,y,S){let v;typeof f=="string"?v=b(c(f)):v=f;let E;y instanceof Date?E=y.getTime():typeof y=="string"&&(E=new Date(y).getTime());let t;if(typeof S=="string"?t=b(c(S)):t=S,!v||!t)return!1;const s=v.majorBase,i=v.minorBase,n=v.patchBase;let r=t.majorBase,o=t.minorBase,a=t.patchBase;const l=t.notBefore;let h=t.majorMustEqual,A=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>o?!0:i<o||E&&E<l?!1:n>=a:(s===1&&r===0&&(!h||!A||!F)&&(r=1,o=0,a=0,h=!0,A=!1,F=!1),s<r?!1:s>r?!h:i<o?!1:i>o?!A:n<a?!1:n>a?!F:!(E&&E<l))}e.isValidVersion=p;function d(f,y,S,v,E){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([R.default.Error,I.localize(0,null)]),t;if(typeof v.name!="string")return t.push([R.default.Error,I.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([R.default.Error,I.localize(2,null,"version")]),t;if(!v.engines)return t.push([R.default.Error,I.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([R.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!u(v.extensionDependencies))return t.push([R.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!u(v.activationEvents))return t.push([R.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([R.default.Error,I.localize(7,null,"activationEvents","main")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([R.default.Warning,I.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([R.default.Error,I.localize(9,null,"main")]),t;{const n=(0,O.joinPath)(S,v.main);(0,O.isEqualOrParent)(n,S)||t.push([R.default.Warning,I.localize(10,null,n.path,S.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,I.localize(11,null,"activationEvents","main")]),t}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([R.default.Error,I.localize(12,null,"browser")]),t;{const n=(0,O.joinPath)(S,v.browser);(0,O.isEqualOrParent)(n,S)||t.push([R.default.Warning,I.localize(13,null,n.path,S.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,I.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(v.version))return t.push([R.default.Error,I.localize(15,null)]),t;const s=[];if(!P(f,y,v,E,s))for(const n of s)t.push([R.default.Error,n]);return t}e.validateExtensionManifest=d;function P(f,y,S,v,E){return v||typeof S.main>"u"&&typeof S.browser>"u"?!0:N(f,y,S.engines.vscode,E)}e.isValidExtensionVersion=P;function m(f,y,S){return f==="*"||N(y,S,f)}e.isEngineValid=m;function N(f,y,S,v=[]){const E=b(c(S));if(!E)return v.push(I.localize(16,null,S)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return v.push(I.localize(17,null,S)),!1}else if(!E.majorMustEqual)return v.push(I.localize(18,null,S)),!1;return p(f,y,E)?!0:(v.push(I.localize(19,null,f,S)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let y=0,S=f.length;y<S;y++)if(typeof f[y]!="string")return!1;return!0}}),define(Z[109],Q([0,1,15,31]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function I(D,k,w){let g=w&&w.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await k.readFile(D.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return w?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=I}),define(Z[45],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(I,D=[],k=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=O}),define(Z[110],Q([0,1,45]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var I;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function D(w,g,c){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(c))),R.push([w,g])}e.registerSingleton=D;function k(){return R}e.getSingletonServiceDescriptors=k}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(D,k){this.key=D,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class R{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const k of this.a.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const w=this.lookupOrInsertNode(D),g=this.lookupOrInsertNode(k);w.outgoing.set(g.key,g),g.incoming.set(w.key,w)}removeNode(D){const k=this.b(D);this.a.delete(k);for(const w of this.a.values())w.outgoing.delete(k),w.incoming.delete(k)}lookupOrInsertNode(D){const k=this.b(D);let w=this.a.get(k);return w||(w=new O(k,D),this.a.set(k,w)),w}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[k,w]of this.a)D.push(`${k}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,k]of this.a){const w=new Set([D]),g=this.c(k,w);if(g)return g}}c(D,k){for(const[w,g]of D.outgoing){if(k.has(w))return[...k,w].join(" -> ");k.add(w);const c=this.c(g,k);if(c)return c;k.delete(w)}}}e.Graph=R}),define(Z[23],Q([0,1,3,11,10]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationOverrides=D;function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=k;var w;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(u,f){const y=Object.create(null);for(const S in u)b(y,S,u[S],f);return y}e.toValuesTree=c;function b(u,f,y,S){const v=f.split("."),E=v.pop();let t=u;for(let s=0;s<v.length;s++){const i=v[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:S(`Ignoring ${f} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[E]=y}catch{S(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function p(u,f){const y=f.split(".");d(u,y)}e.removeFromValueTree=p;function d(u,f){const y=f.shift();if(f.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const S=u[y];typeof S=="object"&&!Array.isArray(S)&&(d(S,f),Object.keys(S).length===0&&delete u[y])}}function P(u,f,y){function S(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const v=f.split("."),E=S(u,v);return typeof E>"u"?y:E}e.getConfigurationValue=P;function m(u,f,y){Object.keys(f).forEach(S=>{S!=="__proto__"&&(S in u?O.isObject(u[S])&&O.isObject(f[S])?m(u[S],f[S],y):y&&(u[S]=f[S]):u[S]=f[S])})}e.merge=m;function N(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=N}),define(Z[58],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Z[17],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[24],Q([0,1,88,10]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function D(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function k(f,y){switch(f){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function w(f,y){return y==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function g(f,y,S){return w(y,S)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===S?!0:c(S).includes(f)}e.isTargetPlatformCompatible=g;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var P;(function(f){f.Install="install",f.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var m;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var N;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(N=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(y,S){super(y),this.code=S,this.name=S}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,O.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((D,k)=>x(["node-vsce-sign"],async w=>D(w),k))),this.a}async verify(D,k){let w;try{w=await this.b()}catch{return!1}return w.verify(D,k)}}e.ExtensionSignatureVerificationService=R}),define(Z[60],Q([0,1,15,7,96,13]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(b,p,d,P,m,N){let u;try{await w(b,p,d,P,m,N)}catch(f){u=f}finally{u&&m.errorTransformer&&(u=m.errorTransformer(u)),typeof u<"u"&&d.error(u),d.end()}}e.readFileIntoStream=k;async function w(b,p,d,P,m,N){g(N);const u=await b.open(p,{create:!1});try{g(N);let f=0,y=0,S=m&&typeof m.length=="number"?m.length:void 0,v=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof S=="number"?S:m.bufferSize)),E=m&&typeof m.position=="number"?m.position:0,t=0;do y=await b.read(u,E,v.buffer,t,v.byteLength-t),E+=y,t+=y,f+=y,typeof S=="number"&&(S-=y),t===v.byteLength&&(await d.write(P(v)),v=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof S=="number"?S:m.bufferSize)),t=0);while(y>0&&(typeof S!="number"||S>0)&&g(N)&&c(f,m));if(t>0){let s=t;typeof S=="number"&&(s=Math.min(t,S)),d.write(P(v.slice(0,s)))}}catch(f){throw(0,D.ensureFileSystemProviderError)(f)}finally{await b.close(u)}}function g(b){if(b.isCancellationRequested)throw(0,R.canceled)();return!0}function c(b,p){if(p?.limits){if(typeof p.limits.memory=="number"&&b>p.limits.memory)throw(0,D.createFileSystemProviderError)((0,I.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&b>p.limits.size)throw(0,D.createFileSystemProviderError)((0,I.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,4,158,2,12,159]),function(x,e,O,R,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends I.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.i(c),p=b.filter(P=>{const m=this.c.get(P.path);return m?!(0,R.patternsEquals)(m.request.excludes,P.excludes)||!(0,R.patternsEquals)(m.request.includes,P.includes):!0}),d=Array.from(this.c.values()).filter(({request:P})=>!b.find(m=>m.path===P.path&&(0,R.patternsEquals)(m.excludes,P.excludes)&&(0,R.patternsEquals)(m.includes,P.includes))).map(({request:P})=>P.path);p.length&&this.j(`Request to start watching: ${p.map(P=>`${P.path} (excludes: ${P.excludes.length>0?P.excludes:"<none>"}, includes: ${P.includes&&P.includes.length>0?JSON.stringify(P.includes):"<all>"})`).join(",")}`),d.length&&this.j(`Request to stop watching: ${d.join(",")}`);for(const P of d)this.h(P);for(const P of p)this.g(P)}g(c){const b=new k.NodeJSFileWatcherLibrary(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),p={request:c,instance:b};this.c.set(c.path,p)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}i(c){const b=new Map;for(const p of c){const d=D.isLinux?p.path:p.path.toLowerCase();b.set(d,p)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=w}),define(Z[113],Q([0,1,61,112]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends O.AbstractNonRecursiveWatcherClient{constructor(k,w,g){super(k,w,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=I}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(g,c,b){super(g,c,b),this.m()}l(g){const c=g.add(new I.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:b,signal:p})=>this.n(`terminated by itself with code ${b}, signal: ${p}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...I){this.a=new Map;for(const[D,k]of I)this.set(D,k)}set(I,D){const k=this.a.get(I);return this.a.set(I,D),k}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=O}),define(Z[115],Q([0,1,5,7,2,45,111,10,62,160]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class p extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class d{constructor(u=new g.ServiceCollection,f=!1,y,S=b){this.f=u,this.g=f,this.h=y,this.i=S,this.o=new Set,this.f.set(w.IInstantiationService,this),this._globalGraph=S?y?._globalGraph??new k.Graph(v=>v):void 0}createChild(u){return new d(u,this.g,this,this.i)}invokeFunction(u,...f){const y=m.traceInvocation(this.i,u);let S=!1;try{return u({get:E=>{if(S)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(E,y);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...f)}finally{S=!0,y.stop()}}createInstance(u,...f){let y,S;return u instanceof D.SyncDescriptor?(y=m.traceCreation(this.i,u.ctor),S=this.j(u.ctor,u.staticArguments.concat(f),y)):(y=m.traceCreation(this.i,u),S=this.j(u,f,y)),y.stop(),S}j(u,f=[],y){const S=w._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),v=[];for(const t of S){const s=this.m(t.id,y);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(s)}const E=S.length>0?S[0].index:f.length;if(f.length!==E){console.trace(`[createInstance] First service dependency of ${u.name} at position ${E+1} conflicts with ${f.length} static arguments`);const t=E-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,E)}return Reflect.construct(u,f.concat(v))}k(u,f){if(this.f.get(u)instanceof D.SyncDescriptor)this.f.set(u,f);else if(this.h)this.h.k(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const f=this.f.get(u);return!f&&this.h?this.h.l(u):f}m(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const y=this.l(u);return y instanceof D.SyncDescriptor?this.q(u,y,f.branch(u,!0)):(f.branch(u,!1),y)}q(u,f,y){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,f,y)}finally{this.o.delete(u)}}r(u,f,y){const S=new k.Graph(t=>t.id.toString());let v=0;const E=[{id:u,desc:f,_trace:y}];for(;E.length;){const t=E.pop();if(S.lookupOrInsertNode(t),v++>1e3)throw new p(S);for(const s of w._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof D.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};S.insertEdge(t,n),E.push(n)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new p(S);break}for(const{data:s}of t){if(this.l(s.id)instanceof D.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}S.removeNode(s)}}return this.l(u)}s(u,f,y=[],S,v){if(this.f.get(u)instanceof D.SyncDescriptor)return this.t(u,f,y,S,v);if(this.h)return this.h.s(u,f,y,S,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(u,f,y=[],S,v){if(S){const E=new d(void 0,this.g,this,this.i);E.c=String(u);const t=new Map,s=new O.IdleValue(()=>{const i=E.j(f,y,v);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const a of r)o.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new c.LinkedList,t.set(n,a)),(h,A,F)=>{const Y=a.push([h,A,F]);return(0,I.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,y,v)}u(u,f){if(f&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=d;var P;(function(N){N[N.None=0]="None",N[N.Creation=1]="Creation",N[N.Invocation=2]="Invocation",N[N.Branch=3]="Branch"})(P||(P={}));class m{static traceInvocation(u,f){return u?new m(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(u,f){return u?new m(1,f.name):m.c}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const y=new m(3,u.toString());return this.h.push([u,f,y]),y}stop(){const u=Date.now()-this.g;m.f+=u;let f=!1;function y(v,E){const t=[],s=new Array(v+1).join("	");for(const[i,n,r]of E.h)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const o=y(v+1,r);o&&t.push(o)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(u>2||f)&&m.all.add(S.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m});var _=this&&this.__param||function(x,e){return function(O,R){e(O,R,x)}};define(Z[63],Q([0,1,22,2,12,98,24,10]),function(x,e,O,R,I,D,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(b){return b.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let c=class extends R.Disposable{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new O.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const m=d.firstPage.filter(N=>N.properties.localizedLanguages?.length&&N.tags.some(u=>u.startsWith("lp-"))).map(N=>{const u=N.properties.localizedLanguages?.[0],f=g(N);return{...this.f(f,u,N),extensionId:N.identifier.id,galleryExtension:N}});return m.push(this.f("en","English")),m}f(p,d,P){const m=d??p;let N;if(m!==p&&(N=`(${p})`),p.toLowerCase()===I.language.toLowerCase()&&(N??="",N+=(0,D.localize)(0,null)),P?.installCount){N??="";const u=P.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),N+=` $(cloud-download) ${f}`}return{id:p,label:m,description:N}}};c=fe([_(0,k.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Z[6],Q([0,1,34,4,2,36,12,3,11,10]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function b(){return new Date().toISOString()}function p(a){return(0,w.isNumber)(a)}e.isLogLevel=p;var d;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function P(a,l,h){switch(l){case d.Trace:a.trace(h);break;case d.Debug:a.debug(h);break;case d.Info:a.info(h);break;case d.Warning:a.warn(h);break;case d.Error:a.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=P;function m(a){let l="";for(let h=0;h<a.length;h++){let A=a[h];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(h>0?" ":"")+A}return l}e.format=m;class N extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==d.Off&&this.b<=l}}e.AbstractLogger=N;class u extends N{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...h){this.f(d.Trace)&&this.g(d.Trace,m([l,...h]))}debug(l,...h){this.f(d.Debug)&&this.g(d.Debug,m([l,...h]))}info(l,...h){this.f(d.Info)&&this.g(d.Info,m([l,...h]))}warn(l,...h){this.f(d.Warning)&&this.g(d.Warning,m([l,...h]))}error(l,...h){if(this.f(d.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(d.Error,m(A))}else this.g(d.Error,m([l,...h]))}flush(){}}e.AbstractMessageLogger=u;class f extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!k.isWindows}trace(l,...h){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}debug(l,...h){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}info(l,...h){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}warn(l,...h){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,l,...h):console.warn(`[main ${b()}]`,l,...h))}error(l,...h){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,l,...h):console.error(`[main ${b()}]`,l,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...h){this.f(d.Trace)&&console.log("%cTRACE","color: #888",l,...h)}debug(l,...h){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...h)}info(l,...h){this.f(d.Info)&&console.log("%c INFO","color: #33f",l,...h)}warn(l,...h){this.f(d.Warning)&&console.log("%c WARN","color: #993",l,...h)}error(l,...h){this.f(d.Error)&&console.log("%c  ERR","color: #f33",l,...h)}dispose(){}flush(){}}e.ConsoleLogger=y;class S extends N{constructor(l,h=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(h)}trace(l,...h){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(l),...h])}debug(l,...h){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(l),...h])}info(l,...h){this.f(d.Info)&&this.g.log(d.Info,[this.h(l),...h])}warn(l,...h){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(l),...h])}error(l,...h){this.f(d.Error)&&this.g.log(d.Error,[this.h(l),...h])}h(l){return typeof l=="string"?l:(0,O.toErrorMessage)(l,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=S;class v extends N{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const h of this.g)h.setLevel(l);super.setLevel(l)}trace(l,...h){for(const A of this.g)A.trace(l,...h)}debug(l,...h){for(const A of this.g)A.debug(l,...h)}info(l,...h){for(const A of this.g)A.info(l,...h)}warn(l,...h){for(const A of this.g)A.warn(l,...h)}error(l,...h){for(const A of this.g)A.error(l,...h)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=v;class E extends I.Disposable{constructor(l,h){if(super(),this.j=l,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,h)for(const A of h)this.c.set(A.resource,A)}getLogger(l){return this.b.get(l)}createLogger(l,h){let A=this.b.get(l);const F=h?.logLevel==="always"?d.Trace:h?.logLevel;return A||(A=this.k(l,F??this.getLogLevel(l)??this.j,h),this.b.set(l,A)),this.registerLogger({resource:l,id:h?.id??l.toString(),logLevel:F,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),A}setLogLevel(l,h){if(g.URI.isUri(l)){const A=l,F=h,Y=this.c.get(A);Y&&F!==Y.logLevel&&(Y.logLevel=F===this.j?void 0:F,this.b.get(A)?.setLevel(F),this.c.set(Y.resource,Y),this.g.fire([A,F]))}else{this.j=l;for(const[A,F]of this.b.entries())this.c.get(A)?.logLevel===void 0&&F.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,h){const A=this.c.get(l);A&&h!==!A.hidden&&(A.hidden=!h,this.c.set(A.resource,A),this.h.fire([l,h]))}getLogLevel(l){let h;return l&&(h=this.c.get(l)?.logLevel),h??this.j}registerLogger(l){const h=this.c.get(l.resource);h?h.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const h=this.c.get(l);if(h){this.c.delete(l);const A=this.b.get(l);A&&(this.b.delete(l),A.dispose()),this.f.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=E;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(l){}getLevel(){return d.Info}trace(l,...h){}debug(l,...h){}info(l,...h){}warn(l,...h){}error(l,...h){}critical(l,...h){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends E{constructor(){super(d.Info)}k(l,h,A){return new t}}e.NullLoggerService=i;function n(a){if(a.verbose)return d.Trace;if(typeof a.logLevel=="string"){const l=o(a.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(a){switch(a){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function o(a){switch(a){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=o}),define(Z[116],Q([0,1,19,5,7,4,2,14,61,6]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends k.Disposable{constructor(d,P){super(),this.a=d,this.b=P,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(d,P){return P.recursive||this.b?.watcher?.forceUniversal?this.l(d,P):this.u(d,P)}l(d,P){const m={path:this.C(d),excludes:P.excludes,includes:P.includes,recursive:P.recursive},N=(0,O.insert)(this.j,m);return this.m(),(0,k.toDisposable)(()=>{N(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(d=>(0,I.onUnexpectedError)(d))}n(){this.h||(this.h=this.B(this.p(P=>this.c.fire((0,g.toFileChanges)(P)),P=>this.z(P),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const P of this.j)(0,g.isRecursiveWatchRequest)(P)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const P of this.j)(0,g.isRecursiveWatchRequest)(P)&&d.includes(P.path)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(d,P){const m={path:this.C(d),excludes:P.excludes,includes:P.includes,recursive:!1},N=(0,O.insert)(this.s,m);return this.v(),(0,k.toDisposable)(()=>{N(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(d=>(0,I.onUnexpectedError)(d))}w(){return this.r||(this.r=this.B(this.y(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}C(d){return(0,w.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Z[117],Q([0,1,19,5,15,22,4,51,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new u.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,P.isAbsolutePath)(t))throw new u.FileOperationError((0,N.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new S.ErrorNoTelemetry;throw i.message=(0,N.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,u.toFileSystemProviderErrorCode)(i)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,N.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await i.stat(t);let h;return this.p(i,t,l,void 0,!!a,(A,F)=>(h||(h=b.TernarySearchTree.forUris(()=>!n),h.set(t,!0),r&&h.fill(!0,r)),h.get(A.resource)||h.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&o?F===1:!1))}async p(t,s,i,n,r,o){const{providerExtUri:a}=this.N(t),l={resource:s,name:a.basename(s),isFile:(i.type&u.FileType.File)!==0,isDirectory:(i.type&u.FileType.Directory)!==0,isSymbolicLink:(i.type&u.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&o(l,n)){try{const h=await t.readdir(s),A=await R.Promises.settled(h.map(async([F,Y])=>{try{const ee=a.joinPath(s,F),te=r?await t.stat(ee):{type:Y};return await this.p(t,ee,te,h.length,r,o)}catch(ee){return this.b.trace(ee),null}}));l.children=(0,O.coalesce)(A)}catch(h){this.b.trace(h),l.children=[]}return l}return l}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,N.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=I.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let a;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof I.VSBuffer))if((0,m.isReadableStream)(s)){const l=await(0,m.peekStream)(s,3);l.ended?a=I.VSBuffer.concat(l.buffer):a=l}else a=(0,m.peekReadable)(s,l=>I.VSBuffer.concat(l),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&a instanceof I.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof I.VSBuffer?(0,I.bufferToReadable)(a):a),this.m.fire(new u.FileOperationEvent(t,4))}catch(o){throw new u.FileOperationError((0,N.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,N.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,N.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,u.etag)({mtime:i.mtime,size:r.size}))throw new u.FileOperationError((0,N.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,o)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,s,i,n);r(a)}catch(a){o(a)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,I.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new D.CancellationTokenSource(n),o=this.F(s,i).then(l=>l,l=>{throw r.cancel(),l});let a;try{return typeof i?.etag=="string"&&i.etag!==u.ETAG_DISABLED&&await o,i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,s,i):(0,u.hasFileReadStreamCapability)(t)?a=this.z(t,s,r.token,i):a=this.C(t,s,r.token,i),{...await o,value:a}}catch(l){throw a&&await(0,m.consumeStream)(a),this.w(l,s,i)}}w(t,s,i){const n=(0,N.localize)(8,null,this.nb(s),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,m.transform)(r,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>this.w(o,s,n)},o=>I.VSBuffer.concat(o))}C(t,s,i,n=Object.create(null)){const r=(0,I.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,s,n)},i),r}D(t,s,i){const n=(0,m.newWriteableStream)(r=>I.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(I.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new u.FileOperationError((0,N.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===i.etag)throw new u.NotModifiedSinceFileOperationError((0,N.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,N.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(s),s);await this.M(r,t,o,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"move",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="move"?2:3,a)),a}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"copy",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="copy"?3:2,a)),a}async I(t,s,i,n,r,o){if(s.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.M(t,s,i,n,r,o);if(a&&!l&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.L(t,h,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:o}),r):(await this.I(t,s,i,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,s,i,n,r,o){let a=!1;if(t===i){const{providerExtUri:h,isPathCaseSensitive:A}=this.N(t);if(A||(a=h.isEqual(s,n)),a&&r==="copy")throw new Error((0,N.localize)(12,null,this.nb(s),this.nb(n)));if(!a&&h.isEqualOrParent(n,s))throw new Error((0,N.localize)(13,null,this.nb(s),this.nb(n)))}const l=await this.exists(n);if(l&&!a){if(!o)throw new u.FileOperationError((0,N.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:h}=this.N(t);if(h.isEqualOrParent(s,n))throw new Error((0,N.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}N(t){const s=this.O(t);return{providerExtUri:s?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&u.FileType.Directory)===0)throw new Error((0,N.localize)(16,null,this.nb(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,N.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,N.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,N.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,u.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,u.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,s);n?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,s){const i=await this.j(t),n=(0,w.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(n)||(0,m.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=I.VSBuffer.concat(i.buffer);await this.bb(t,s,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,a)=>{(0,m.listenStream)(r,{onData:async l=>{r.pause();try{await this.bb(t,s,l,l.byteLength,n,0)}catch(h){return a(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>a(l),onEnd:()=>o()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,o){let a=0;for(;a<n;)a+=await t.write(s,r+a,i.buffer,o+a,n-a)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof I.VSBuffer?r=n:(0,m.isReadableStream)(n)?r=await(0,I.streamToBuffer)(n):(0,m.isReadableBufferedStream)(n)?r=await(0,I.bufferedStreamToBuffer)(n):r=(0,I.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,o;try{r=await t.open(s,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const a=I.VSBuffer.alloc(this.a);let l=0,h=0,A=0;do A=await t.read(r,l,a.buffer,h,a.byteLength-h),await this.bb(i,o,a,A,l,h),l+=A,h+=A,h===a.byteLength&&(h=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.bb(i,r,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,I.streamToBuffer)(this.C(t,s,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new u.FileOperationError((0,N.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,N.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};v=fe([_(0,y.ILogService)],v),e.FileService=v}),define(Z[119],Q([0,1,120,161,5,36,15,4,162,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(s)}`)}})();class t extends y.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=w.Event.None,this.H=new D.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await m.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await m.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,d.joinPath)(i,o.name))).type:a=this.G(o),r.push([o.name,a])}catch(a){this.a.trace(a)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=u.FileType.Unknown:i.isFile()?r=u.FileType.File:i.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new I.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await m.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,P.newWriteableStream)(a=>k.VSBuffer.concat(a.map(l=>k.VSBuffer.wrap(l))).buffer);return(0,f.readFileIntoStream)(this,i,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const a=this.C(i);if(!r.create||!r.overwrite){if(await m.Promises.exists(a)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,N.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,N.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,u.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let a;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(r);h.mode&128||await m.Promises.chmod(r,h.mode|128)}catch(h){this.a.trace(h)}let l;if((0,u.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await m.Promises.truncate(r,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}l||(l="w")}else l="r";a=await m.Promises.open(r,l)}catch(l){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.Z(i,l):this.Y(l)}if(this.L.set(a,0),(0,u.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),o){const l=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,o),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),l.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await m.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await m.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,a){const l=this.P(i,n);let h=null;try{h=(await m.Promises.read(i,r,o,a,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,h)}return h}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,a){return(0,I.retry)(()=>this.R(i,n,r,o,a),100,3)}async R(i,n,r,o,a){const l=this.P(i,n);let h=null;try{h=(await m.Promises.write(i,r,o,a,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,h)}return h}async mkdir(i){try{await m.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"move",r.overwrite),await m.Promises.move(o,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(2,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(a)),l.toString()))),this.Y(l)}}async copy(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"copy",r.overwrite),await m.Promises.copy(o,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(3,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(a)),l.toString()))),this.Y(l)}}async S(i,n,r,o){const a=this.C(i),l=this.C(n);let h=!1;if(!!(this.capabilities&1024)||(h=(0,g.isEqual)(a,l,!0)),h&&r==="copy")throw(0,u.createFileSystemProviderError)((0,N.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!h&&await m.Promises.exists(l)){if(!o)throw(0,u.createFileSystemProviderError)((0,N.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),a=this.C(n),l=!!(this.capabilities&1024);if((0,g.isEqual)(o,a,!l))return;const h=new c.DisposableStore;try{const[A,F]=await Promise.all([this.I(i),this.I(n)]);h.add(A),h.add(F),r&&await m.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await m.Promises.copyFile(o,a)}catch(A){if(A.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(A)}finally{h.dispose()}}p(i,n,r){return new v.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new E.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof u.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Z[121],Q([0,1,2,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends O.Disposable{constructor(k,w=[]){super(),this.a=new R.MultiplexLogger([k,...w]),this.B(k.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...w){this.a.trace(k,...w)}debug(k,...w){this.a.debug(k,...w)}info(k,...w){this.a.info(k,...w)}warn(k,...w){this.a.warn(k,...w)}error(k,...w){this.a.error(k,...w)}flush(){this.a.flush()}}e.LogService=I}),define(Z[122],Q([0,1,13,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(I||(I={}));async function D(c,b,p,d,P){try{const m=await new Promise((u,f)=>{x(["spdlog"],u,f)});m.setFlushOn(I.Trace);const N=await m.createAsyncRotatingLogger(c,b,p,d);return P?N.clearFormatters():N.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),N}catch(m){console.error(m)}return null}function k(c,b,p){switch(b){case R.LogLevel.Trace:c.trace(p);break;case R.LogLevel.Debug:c.debug(p);break;case R.LogLevel.Info:c.info(p);break;case R.LogLevel.Warning:c.warn(p);break;case R.LogLevel.Error:c.error(p);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function w(c,b){switch(b){case R.LogLevel.Trace:c.setLevel(I.Trace);break;case R.LogLevel.Debug:c.setLevel(I.Debug);break;case R.LogLevel.Info:c.setLevel(I.Info);break;case R.LogLevel.Warning:c.setLevel(I.Warning);break;case R.LogLevel.Error:c.setLevel(I.Error);break;case R.LogLevel.Off:c.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends R.AbstractMessageLogger{constructor(b,p,d,P,m){super(),this.k=[],this.setLevel(m),this.l=this.n(b,p,d,P),this.B(this.onDidChangeLogLevel(N=>{this.m&&w(this.m,N)}))}async n(b,p,d,P){const m=d?6:1,N=30/m*O.ByteSize.MB,u=await D(b,p,N,m,P);if(u){this.m=u,w(this.m,this.getLevel());for(const{level:f,message:y}of this.k)k(this.m,f,y);this.k=[]}}g(b,p){this.m?k(this.m,b,p):this.getLevel()<=b&&this.k.push({level:b,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[38],Q([0,1,4,64,2,10]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class k extends I.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.i(c),R.Iterable.reduce(this.g.entries(),(p,[d,P])=>({...p,[d]:P}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[b,p])=>({...c,[b]:{definition:p,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=k;class w{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(Z[123],Q([0,1,5,4,64,3,13,6,38]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(p,d){const P=[];for(const m of new Set(I.Iterable.concat(p.keys(),d.keys())))p.get(m)!==d.get(m)&&P.push(m);return P}let b=class extends g.AbstractPolicyService{constructor(d,P,m){super(),this.j=d,this.k=P,this.l=m,this.c=this.B(new O.ThrottledDelayer(500));const N=R.Event.filter(P.onDidFilesChange,u=>u.affects(d));this.B(P.watch(d)),this.B(N(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const d=new Map;try{const P=await this.k.readFile(this.j),m=JSON.parse(P.value.toString());if(!(0,D.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const N of Object.keys(m))this.f[N]&&d.set(N,m[N])}catch(P){P.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",P)}return d}async p(){const d=await this.n(),P=c(this.g,d);this.g=d,P.length>0&&this.h.fire(P)}};b=fe([_(1,k.IFileService),_(2,w.ILogService)],b),e.FilePolicyService=b}),define(Z[28],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(k,w){O.ok(R.isString(k)),O.ok(R.isObject(w)),O.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,w)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new I}),define(Z[124],Q([0,1,4,37]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[I(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const k=new D;R.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[42],Q([0,1,19,4,3,86,23,124,37]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=g.Registry.as(w.Extensions.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.a.get(o),l=a?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[o]))l.set(Y,r);const h={...a?.value||{},...n[o]};this.a.set(o,{source:r,value:h,valuesSources:l});const A=(0,k.getLanguageTagSettingPlainKey)(o),F={type:"object",default:h,description:D.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:I.isString(r)?void 0:r,defaultValueSource:r};i.push(...N(o)),this.d[o]=F,this.b.properties[o]=F}else{this.a.set(o,{value:n[o],source:r});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),a=I.isString(n)?n:n?.id,l=I.isString(o?.source)?o?.source:o?.source?.id;if(a===l)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,o){r=I.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const h in a){const A=a[h];if(s&&S(h,A)){delete a[h];continue}if(A.source=i,A.defaultDefaultValue=a[h].default,this.w(h,A),e.OVERRIDE_PROPERTY_REGEX.test(h)?A.scope=void 0:(A.scope=I.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=I.isUndefinedOrNull(A.restricted)?!!n?.includes(h):A.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.f[h]=a[h],delete a[h];continue}else this.d[h]=a[h],a[h].policy?.name&&this.e.set(a[h].policy.name,h);!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),o.add(h)}const l=t.allOf;if(l)for(const h of l)this.p(h,s,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;I.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),I.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const P="\\[([^\\]]+)\\]",m=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function N(E){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let s=m.exec(E);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=m.exec(E)}}return(0,O.distinct)(t)}e.overrideIdentifiersFromKey=N;function u(E){return E.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const y=new d;g.Registry.add(e.Extensions.Configuration,y);function S(E,t){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?D.localize(7,null,E):y.getConfigurationProperties()[E]!==void 0?D.localize(8,null,E):t.policy?.name&&y.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,E,t.policy?.name,y.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=S;function v(){const E=[],t=y.getConfigurationProperties();for(const s of Object.keys(t))E.push([s,t[s].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=v}),define(Z[65],Q([0,1,19,4,49,2,36,30,3,11,23,42,37]),function(x,e,O,R,I,D,k,w,g,c,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function P(s){return Object.isFrozen(s)?s:w.deepFreeze(s)}class m{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof m)return n;const r=new N("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:a}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,b.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return O.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=w.deepClone(this.contents),r=w.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const l of i)if(a.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const h of l.overrides){const[A]=r.filter(F=>O.equals(F.identifiers,h.identifiers));A?(this.h(A.contents,h.contents),A.keys.push(...h.keys),A.keys=O.distinct(A.keys)):r.push(w.deepClone(h))}for(const h of l.keys)o.indexOf(h)===-1&&o.push(h)}return new m(n,o,r,a.every(l=>l instanceof m)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const l=n[o];l&&(typeof a=="object"&&typeof l=="object"?(a=w.deepClone(a),this.h(a,l)):a=l),r[o]=a}return new m(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=w.deepClone(n[r])}}i(i){let n=null,r=null;const o=a=>{a&&(r?this.h(r,a):r=w.deepClone(a))};for(const a of this.overrides)O.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,b.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=m;class N{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:a,restricted:l,hasExcludedProperties:h}=this.h(i,n);this.b=new m(r,o,a,h?[i]:void 0),this.c=l||[]}g(i){let n={},r=null,o=[];const a=[],l=[];function h(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}const A={onObjectBegin:()=>{const F={};h(F),a.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const F=[];h(F),a.push(o),o=F,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:h,onError:(F,Y,ee)=>{l.push({error:F,offset:Y,length:ee})}};if(i)try{I.visit(i,A),n=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const a=(0,b.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),h=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:a,keys:l,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const l={},h=[];for(const A in i)if(p.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const F=this.i(i[A],n,!1,o);l[A]=F.raw,a=a||F.hasExcludedProperties,h.push(...F.restricted)}else{const F=n[A],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&h.push(A),(Y===void 0||o.scopes===void 0||o.scopes.includes(Y))&&!(o.skipRestricted&&F?.restricted)?l[A]=i[A]:a=!0}return{raw:l,restricted:h,hasExcludedProperties:a}}j(i,n){const r=[];for(const o of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in i[o])a[l]=i[o][l];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,b.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=N;class u extends D.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new N(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class f{constructor(i,n,r,o,a,l,h,A,F,Y,ee,te,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=a,this.f=l,this.g=h,this.h=A,this.i=F,this.j=Y,this.k=ee,this.l=te,this.m=ie}get value(){return P(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return P(o.value)},get override(){return P(o.override)},get merged(){return P(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class y{constructor(i,n,r,o,a=new m,l=new m,h=new k.ResourceMap,A=new m,F=new k.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=a,this.i=l,this.j=h,this.l=A,this.m=F,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new m,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),a=this.u(n.resource,r),l=n.resource?this.m.get(n.resource)||this.l:this.l,h=new Set;for(const A of o.overrides)for(const F of A.identifiers)o.getOverrideValue(i,F)!==void 0&&h.add(F);return new f(i,n,o.getValue(i),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,l)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:a,removed:l}=E(this.c,i);n=[...o,...a,...l]}for(const o of n)for(const a of(0,p.overrideIdentifiersFromKey)(o)){const l=this.c.getKeysForOverrideIdentifier(a),h=i.getKeysForOverrideIdentifier(a),A=[...h.filter(F=>l.indexOf(F)===-1),...l.filter(F=>h.indexOf(F)===-1),...l.filter(F=>!w.equals(this.c.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=E(this.d,i),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.applicationConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.localUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.remoteUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.workspaceConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:a,removed:l,overrides:h}=E(r,n),A=[...o,...a,...l];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:h}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:a,overrides:l}=E(n,void 0);return{keys:[...r,...o,...a],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const a=this.m.get(i);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:a}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),a=this.x(i.user),l=this.x(i.workspace),h=i.folders.reduce((A,F)=>(A.set(c.URI.revive(F[0]),this.x(F[1])),A),new k.ResourceMap);return new y(n,r,o,a,new m,l,h,new m,new k.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=y;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,l])=>{const h=(0,k.getOrSet)(n,a,new Set);l.forEach(A=>h.add(A))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class v{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const l of a)this.affectedKeys.add(l);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=y.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this.d.length)return!1;const l=this.d.charCodeAt(a);if(l!==this.b&&l!==this.c)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,A=this.g.getValue(i,n,this.h);return!w.equals(h,A)}return!0}}e.ConfigurationChangeEvent=v;function E(s,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,s?.rawConfiguration),a=[],l=s?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const A=h.filter(F=>!l.includes(F));for(const F of A)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const A=l.filter(F=>!h.includes(F));for(const F of A)a.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const A of l)if(h.includes(A)){const F=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});a.push([A,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function t(s,i){const n=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],r=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const l=(0,b.getConfigurationValue)(i.contents,a),h=(0,b.getConfigurationValue)(s.contents,a);w.equals(l,h)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(Z[125],Q([0,1,19,4,2,30,3,65,42,6,38,37]),function(x,e,O,R,I,D,k,w,g,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends I.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.c(Array.from(u),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,f){this.h(u,p.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new w.ConfigurationModel;const u=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,f){const y=this.f();for(const S of u){const v=y[S],E=f[S];v!==void 0?this.b.addValue(S,v):E?this.b.addValue(S,E.default):this.b.removeValue(S)}}}e.DefaultConfiguration=d;class P{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let m=class extends I.Disposable{get configurationModel(){return this.b}constructor(u,f,y){super(),this.c=u,this.f=f,this.g=y,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},y=[],S=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const v of u){const E=S[v];if(!E){y.push(v);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}y.push(v),f[E.policy.name]={type:E.type}}}return(0,k.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),y}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const f=p.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),y=(0,O.coalesce)(u.map(S=>f.get(S)));this.j(y,!0)}j(u,f){this.g.trace("PolicyConfiguration#update",u);const y=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),S=[],v=this.b.isEmpty();for(const E of u){const t=y[E]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(v?s!==void 0:!(0,D.equals)(this.b.getValue(E),s))&&S.push([E,s])}else this.b.getValue(E)!==void 0&&S.push([E,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const E=this.b;this.b=new w.ConfigurationModel;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,s]of S)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};m=fe([_(1,b.IPolicyService),_(2,c.ILogService)],m),e.PolicyConfiguration=m}),define(Z[126],Q([0,1,5,4,2,18,23,65,125,38]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends I.Disposable{constructor(d,P,m,N){super(),this.i=d,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=m instanceof c.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,m,N)),this.f=this.B(new w.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,P)),this.a=new w.Configuration(this.b.configurationModel,this.c.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.g=this.B(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:f})=>this.k(u,f))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,P,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.Configuration(d,P,new w.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(d,P){const m=typeof d=="string"?d:void 0,N=(0,k.isConfigurationOverrides)(d)?d:(0,k.isConfigurationOverrides)(P)?P:{};return this.a.getValue(m,N,void 0)}updateValue(d,P,m,N){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.j(d)}j(d){const P=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(d);this.m(m,P,2)}k(d,P){const m=this.a.toData(),N=this.a.compareAndUpdateDefaultConfiguration(d,P);this.m(N,m,7)}l(d){const P=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(d);this.m(m,P,7)}m(d,P,m){const N=new w.ConfigurationChangeEvent(d,{data:P},this.a);N.source=m,N.sourceConfig=this.n(m),this.h.fire(N)}n(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Z[66],Q([0,1,16]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(c){return c.scheme===O.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=R;function I(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.getRemoteName=I;function D(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=D;function k(c){const{host:b,port:p}=g(c);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:p}}e.parseAuthorityWithPort=k;function w(c,b){let{host:p,port:d}=g(c);return typeof d>"u"&&(d=b),{host:p,port:d}}e.parseAuthorityWithOptionalPort=w;function g(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const p=c.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(Z[29],Q([0,1,32,10,66]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=D;function k(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var g;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class c{constructor(N){this.value=N,this.c=N.toLowerCase()}static equals(N,u){if(typeof N>"u"||N===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof N=="string"||typeof u=="string"){const f=typeof N=="string"?N:N.value,y=typeof u=="string"?u:u.value;return O.equalsIgnoreCase(f,y)}return N.c===u.c}static toKey(N){return typeof N=="string"?N.toLowerCase():N.c}}e.ExtensionIdentifier=c;function b(m){return p(m)}e.isApplicationScopedExtension=b;function p(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function P(m,N){if(N){const u=`onResolveRemoteAuthority:${(0,I.getRemoteName)(N)}`;return m.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[127],Q([0,1,2,14,20,29]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends O.Disposable{constructor(g,c){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(b=>this.c(b))),this.B(c.onDidUninstallExtension(b=>this.f(b)))}c(g){g.some(c=>!!c.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){I.Promises.rm(this.a,I.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[46],Q([0,1,15,99,42,10,37]),function(x,e,O,R,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function w(N){return N.res.statusCode&&N.res.statusCode>=200&&N.res.statusCode<300||N.res.statusCode===1223}e.isSuccess=w;function g(N){return N.res.statusCode===204}async function c(N){return g(N)?null:(await(0,O.streamToBuffer)(N.stream)).toString()}e.asText=c;async function b(N){if(!w(N))throw new Error("Server returned "+N.res.statusCode);return c(N)}e.asTextOrError=b;async function p(N){if(!w(N))throw new Error("Server returned "+N.res.statusCode);if(g(N))return null;const f=(await(0,O.streamToBuffer)(N.stream)).toString();try{return JSON.parse(f)}catch(y){throw y.message+=`:
`+f,y}}e.asJson=p;function d(N){m(N)}e.updateProxyConfigurationsScope=d;let P;function m(N){const u=k.Registry.as(I.Extensions.Configuration),f=P;P={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:N,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[P],remove:f?[f]:[]})}m(2)}),define(Z[128],Q([0,1,22,16,13,46]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,b=O.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,c);return}const p={type:"GET",url:g.toString(!0)},d=await this.a.request(p,b);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const P=await(0,D.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${P}`)}}};k=fe([_(0,D.IRequestService),_(1,I.IFileService)],k),e.DownloadService=k}),define(Z[129],Q([0,1,130,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function I(k,w){return k.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:k.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(k,w,g={}){const c=(0,O.parse)(k),b=g.proxyUrl||I(c,w);if(!b)return null;const p=(0,O.parse)(b);if(!/^https?:$/.test(p.protocol||""))return null;const d={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((P,m)=>{x(["http-proxy-agent"],P,m)}))(d):new(await new Promise((P,m)=>{x(["https-proxy-agent"],P,m)}))(d)}e.getProxyAgent=D}),define(Z[131],Q([0,1,57,14,100,22,34,7,12,31,82,163,5,71]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function N(f,y,S,v){return S["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(v)&&!S["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(v)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=d.Promises.withAsyncBody(async(E,t)=>{const s=new D.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,P.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,I.localize)(0,null)))},i);try{E(await u(y,s.token))}catch(o){!(0,w.isCancellationError)(o)&&!s.token.isCancellationRequested?t(new Error((0,I.localize)(1,null,(0,k.toErrorMessage)(o)))):E({})}finally{clearTimeout(r),s.dispose()}})),m)}e.getResolvedShellEnv=N;async function u(f,y){const S=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",S);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const E=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,b.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(y.isCancellationRequested)return r(new w.CancellationError);const o=(0,R.basename)(i);let a,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${h} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${h} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,o==="tcsh"||o==="csh"?l=["-ic"]:l=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const A=(0,O.spawn)(i,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(A.kill(),r(new w.CancellationError))),A.on("error",ee=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(ee)),r(ee)});const F=[];A.stdout.on("data",ee=>F.push(ee));const Y=[];A.stderr.on("data",ee=>Y.push(ee)),A.on("close",(ee,te)=>{const ie=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),ee||te)return r(new Error((0,I.localize)(2,null,ee,te)));const ae=t.exec(ie),ue=ae?ae[1]:"{}";try{const se=JSON.parse(ue);S?se.ELECTRON_RUN_AS_NODE=S:delete se.ELECTRON_RUN_AS_NODE,v?se.ELECTRON_NO_ATTACH_CONSOLE=v:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(se)),r(se)}})})}}),define(Z[67],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,O.createDecorator)("stateService")}),define(Z[132],Q([0,1,5,15,3,17,13,6]),function(x,e,O,R,I,D,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(p,d,P){this.f=p,this.g=d,this.h=P,this.a=Object.create(null),this.b="",this.c=new O.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,d){const P=this.a[p];return(0,I.isUndefinedOrNull)(P)?d:P}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:P,data:m}of p)this.a[P]!==m&&((0,I.isUndefinedOrNull)(m)?(0,I.isUndefined)(this.a[P])||(this.a[P]=void 0,d=!0):(this.a[P]=m,d=!0));d&&this.j()}removeItem(p){(0,I.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(p)),this.b=p}catch(d){this.g.error(d)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let c=class{constructor(p,d,P){this.a=new g(p.stateResource,d,P)}async init(){await this.a.init()}getItem(p,d){return this.a.getItem(p,d)}};c=fe([_(0,D.IEnvironmentService),_(1,w.ILogService),_(2,k.IFileService)],c),e.StateService=c}),define(Z[68],Q([0,1,12,35,11,31]),function(x,e,O,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(c){if(O.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function w(c,b,p,d,P,m,N,u,f,y){const S=Object.create(null);S["common.machineId"]=N,S.sessionID=(0,D.generateUuid)()+Date.now(),S.commitHash=P,S.version=m,S["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,O.PlatformToString)(O.platform),S["common.nodePlatform"]=R.platform,S["common.nodeArch"]=d,S["common.product"]=y||"desktop",u&&(S["common.msftInternal"]=u);let v=0;const E=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),O.isLinuxSnap&&(S["common.snap"]="true");const t=k(p);t&&(S["common.platformDetail"]=t);try{const s=await c.readFile(I.URI.file(f));S["common.source"]=s.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=w;function g(c){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const p=b.toLowerCase();return c.some(d=>p===d)}e.verifyMicrosoftInternalDomain=g}),define(Z[25],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,30,3,4,23,66,68,25]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(a){this.value=a}}e.TelemetryTrustedValue=c;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,l){return Promise.resolve(void 0)}publicLog2(a,l){return this.publicLog(a,l)}publicLogError(a,l){return Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class p{async publicLog(a,l,h){}async publicLogError(a,l,h){}}e.NullEndpointTelemetryService=p,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(o,a){return I.Event.debounce(a.onDidChangeConfiguration,(h,A)=>{const F=h?new Set([...h.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:F}},1e3,!0)(h=>{h.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(h.source),configurationKeys:v(h.affectedKeys)})})}e.configurationTelemetry=d;function P(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=P;function m(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=m;function N(o){const a=o.getValue(g.TELEMETRY_SETTING_ID),l=o.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=N;function u(o){const a={},l={},h={};S(o,h);for(let A in h){A=A.length>150?A.substr(A.length-149):A;const F=h[A];typeof F=="number"?l[A]=F:typeof F=="boolean"?l[A]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${F.length}`),a[A]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[A]=F)}return{properties:a,measurements:l}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function y(o){if(!o)return"none";const a=(0,k.getRemoteName)(o);return f.has(a)?a:"other"}e.cleanRemoteAuthority=y;function S(o,a,l=0,h){if(!!o)for(const A of Object.getOwnPropertyNames(o)){const F=o[A],Y=h?h+A:A;Array.isArray(F)?a[Y]=(0,O.safeStringify)(F):F instanceof Date?a[Y]=F.toISOString():(0,R.isObject)(F)?l<2?S(F,a,l+1,Y+"."):a[Y]=(0,O.safeStringify)(F):a[Y]=F}}function v(o){if(!o)return[];const a=[];return E(a,"",o),a}function E(o,a,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(h=>E(o,a?`${a}.${h}`:h,l[h])):o.push(a)}function t(o,a){const l=o.msftInternalDomains||[],h=a.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=t;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let l=o;const h=[];for(const ee of a)for(;;){const te=ee.exec(o);if(!te)break;h.push([te.index,ee.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(l="";;){const ee=F.exec(o);if(!ee)break;const te=h.some(([ie,ne])=>ee.index<ne&&ie<F.lastIndex);!A.test(ee[0])&&!te&&(l+=o.substring(Y,ee.index)+"<REDACTED: user-file-path>",Y=F.lastIndex)}return Y<o.length&&(l+=o.substr(Y)),l}function n(o){if(!o)return o;const a=o.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(a))return`<REDACTED: ${h.label}>`;return o}function r(o,a){return(0,O.cloneAndChange)(o,l=>{if(l instanceof c)return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=i(h,a);for(const A of a)h=h.replace(A,"");return h=n(h),h}})}e.cleanData=r}),define(Z[26],Q([0,1,32,24,29,12,11,7,35,39]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,O.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=b;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=p.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const n=P.exec(i);return n&&n[1]?[u(n[1]),n[2]]:[u(i),void 0]}e.getIdAndVersion=m;function N(i,n){return`${i}.${n}`}e.getExtensionId=N;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(i,n){return u(N(i,n))}e.getGalleryExtensionId=f;function y(i,n){const r=[],o=a=>{for(const l of r)if(l.some(h=>b(n(h),n(a))))return l;return null};for(const a of i){const l=o(a);l?l.push(a):r.push([a])}return r}e.groupByExtension=y;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function v(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function E(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(l=>!b(l.identifier,{id:a}))){const l=i.filter(h=>b(h.identifier,{id:a}));l.length===1&&(r.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=E;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function s(i,n){const r=await t(i,n),o=(0,R.getTargetPlatform)(r?"alpine":D.platform,g.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Z[133],Q([0,1,22,7,16,18,41,11,89,24,26,29]),function(x,e,O,R,I,D,k,w,g,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=u=>(0,g.localize)(0,null,u),P=(0,g.localize)(1,null,"ms-dotnettools.csharp");function m(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let N=class{constructor(f,y){this.a=f,this.b=y}get d(){}async listExtensions(f,y,S,v=console){let E=await this.a.getInstalled(1,S);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(y&&y!==""){if(t.indexOf(y.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}E=E.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){v.log("Possible Categories: "),t.forEach(i=>{v.log(i)});return}this.d&&v.log((0,g.localize)(2,null,this.d)),E=E.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of E)s!==i.identifier.id&&(s=i.identifier.id,v.log(m(i.manifest,f)))}async installExtensions(f,y,S,v,E=console){const t=[],s=[];f.length&&E.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,S.profileLocation),n=(l,h)=>{const A=i.find(F=>(0,b.areSameExtensions)(F.identifier,{id:l}));if(A){if(!v&&(!h||h==="prerelease"&&A.preRelease))return E.log((0,g.localize)(5,null,l,A.manifest.version,l)),!1;if(h&&A.manifest.version===h)return E.log((0,g.localize)(6,null,`${l}@${h}`)),!1}return!0},r=(l,h,A)=>{a.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...S,isBuiltin:A,installPreReleaseVersion:h==="prerelease"||S.installPreReleaseVersion}})},o=[],a=[];for(const l of f)if(l instanceof w.URI)o.push(l);else{const[h,A]=(0,b.getIdAndVersion)(l);n(h,A)&&r(h,A,!1)}for(const l of y){const[h,A]=(0,b.getIdAndVersion)(l);n(h,A)&&r(h,A,!0)}if(o.length&&await Promise.all(o.map(async l=>{try{const h=await this.f(l,{...S,isBuiltin:!1},v,E);h&&s.push(h)}catch(h){E.error(h.message||h.stack||h),t.push(l.toString())}})),a.length){const l=await this.g(a);await Promise.all(a.map(async h=>{const A=l.get(h.id.toLowerCase());if(A)try{const F=await this.h(h,A,i,v,E);F&&s.push(F)}catch(F){E.error(F.message||F.stack||F),t.push(h.id)}else E.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${P}`),t.push(h.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(f,y,S,v){const E=await this.a.getManifest(f);if(!E)throw new Error("Invalid vsix");if(await this.k(E,S,y.profileLocation,v))try{return await this.a.install(f,y),v.log((0,g.localize)(8,null,(0,D.basename)(f))),E}catch(s){if((0,R.isCancellationError)(s))return v.log((0,g.localize)(9,null,(0,D.basename)(f))),null;throw s}return null}async g(f){const y=new Map,S=f.some(E=>E.installOptions.installPreReleaseVersion),v=await this.b.getExtensions(f.map(E=>({...E,preRelease:S})),O.CancellationToken.None);for(const E of v)y.set(E.identifier.id.toLowerCase(),E);return y}async h({id:f,version:y,installOptions:S},v,E,t,s){const i=await this.b.getManifest(v,O.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=E.find(r=>(0,b.areSameExtensions)(r.identifier,v.identifier));if(n){if(v.version===n.manifest.version)return s.log((0,g.localize)(10,null,y?`${f}@${y}`:f)),null;s.log((0,g.localize)(11,null,f,v.version))}try{S.isBuiltin?s.log(y?(0,g.localize)(12,null,f,y):(0,g.localize)(13,null,f)):s.log(y?(0,g.localize)(14,null,f,y):(0,g.localize)(15,null,f));const r=await this.a.installFromGallery(v,{...S,installGivenVersion:!!y});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}j(f,y){return!0}async k(f,y,S,v){const E={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.a.getInstalled(1,S)).find(i=>(0,b.areSameExtensions)(E,i.identifier)&&(0,k.gt)(i.manifest.version,f.version));return s&&!y?(v.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.j(f,v)}async uninstallExtensions(f,y,S,v=console){const E=async s=>{if(s instanceof w.URI){const i=await this.a.getManifest(s);return m(i)}return s},t=[];for(const s of f){const i=await E(s),r=(await this.a.getInstalled(void 0,S)).filter(o=>(0,b.areSameExtensions)(o.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${P}`);if(r.some(o=>o.type===0)){v.log((0,g.localize)(19,null,i));return}if(!y&&r.some(o=>o.isBuiltin)){v.log((0,g.localize)(20,null,i));return}v.log((0,g.localize)(21,null,i));for(const o of r)await this.a.uninstall(o,{profileLocation:S}),t.push(o);this.d?v.log((0,g.localize)(22,null,i,this.d)):v.log((0,g.localize)(23,null,i))}}async locateExtension(f,y=console){const S=await this.a.getInstalled();f.forEach(v=>{S.forEach(E=>{if(E.identifier.id===v&&E.location.scheme===I.Schemas.file){y.log(E.location.fsPath);return}})})}l(f){return this.d?(0,g.localize)(24,null,f,this.d):(0,g.localize)(25,null,f)}};N=fe([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],N),e.ExtensionManagementCLI=N}),define(Z[134],Q([0,1,5,7,2,16,12,18,41,3,31,20,23,17,24,26,59,13,6,28]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class $e extends I.Disposable{constructor(t,s,i,n,r,o,a){super(),this.h=s,this.i=i,this.j=n,this.k=r,this.l=o,this.m=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,s){await this.g;const i=(0,w.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,r=>this.i.download(t,r,s))}catch(r){throw new m.ExtensionManagementError(r.message,m.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const r=await this.r(t);try{await this.l.verify(i.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(o){const a=o.code;if(a==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(i),new m.ExtensionManagementError(a,m.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const s=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(s)?s:this.k.quality!=="stable"}async r(t){await this.g;const s=(0,w.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${$e.c}`);return await this.t(t,s,i=>this.i.downloadSignatureArchive(t,i)),s}async t(t,s,i){if(await this.h.exists(s))return;if(s.scheme!==D.Schemas.file){await i(s);return}const n=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,s,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.m.info(`Rename failed because of ${(0,R.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async u(t,s,i){try{await p.Promises.rename(t.fsPath,s.fsPath)}catch(n){if(k.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${s} with 'EPERM' error. Trying again...`),this.u(t,s,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],i=[],n=[];for(const a of t.children)if(a.name.endsWith($e.c))n.push(a.resource);else{const l=N.ExtensionKey.parse(a.name);l&&i.push([l,a])}const r=(0,N.groupByExtension)(i,([a])=>a),o=[];for(const a of r)a.sort((l,h)=>g.rcompare(l[0].version,h[0].version)),s.push(...a.slice(1).map(l=>l[1].resource)),o.push(a[0][1]);o.sort((a,l)=>a.mtime-l.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),s.push(...n),await O.Promises.settled(s.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.m.error(t)}}w(t){return this.f?N.ExtensionKey.create(t).toString().toLowerCase():(0,b.generateUuid)()}};v.c=".sigzip",v=fe([_(0,P.INativeEnvironmentService),_(1,f.IFileService),_(2,m.IExtensionGalleryService),_(3,d.IConfigurationService),_(4,S.IProductService),_(5,u.IExtensionSignatureVerificationService),_(6,y.ILogService)],v),e.ExtensionsDownloader=v}),define(Z[135],Q([0,1,4,2,36,26,29]),function(x,e,O,R,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends R.Disposable{constructor(c,b,p,d,P,m,N){super(),this.f=c,this.g=b,this.h=p,this.i=d,this.j=P,this.k=m,this.l=N,this.a=this.B(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,u=>N.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,b){try{await Promise.all(b.map(p=>(this.c.deleteAndDispose(p.id),this.z(p.extensionsResource)))),c.length&&await Promise.all(c.map(p=>(this.c.set(p.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(p.extensionsResource)),this.k.watch(p.extensionsResource))),this.y(p.extensionsResource))))}catch(p){throw this.l.error(p),p}}async r(c){for(const b of c.extensions)this.D(this.G(b.identifier,b.version),c.profileLocation)}async s(c){for(const b of c.extensions){const p=this.G(b.identifier,b.version);c.error?this.F(p,c.profileLocation):this.D(p,c.profileLocation)}}async t(c){for(const b of c.extensions)this.F(this.G(b.identifier,b.version),c.profileLocation)}async u(c){let b=!1;for(const p of c.extensions){const d=this.G(p.identifier,p.version);c.error?this.D(d,c.profileLocation):(this.F(d,c.profileLocation),b=b||!this.b.has(d))}b&&await this.C()}v(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.w(b.extensionsResource)}async w(c){const b=[],p=[],d=await this.i.scanProfileExtensions(c),P=new Set,m=new Set;for(const[N,u]of this.b)u.has(c)&&m.add(N);for(const N of d){const u=this.G(N.identifier,N.version);P.add(u),m.has(u)||(b.push(N.identifier),this.D(u,c))}for(const N of m)if(!P.has(N)){const u=this.H(N);u&&(p.push(u.identifier),this.F(N,c))}(b.length||p.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:p.length?{extensions:p,profileLocation:c}:void 0})}async y(c){const b=await this.i.scanProfileExtensions(c);for(const p of b)this.D(this.G(p.identifier,p.version),c)}async z(c){for(const b of[...this.b.keys()])this.F(b,c);await this.C()}async C(){const b=(await this.f.getAllUserInstalled()).filter(p=>p.installedTimestamp&&!this.b.has(this.G(p.identifier,p.manifest.version)));b.length&&await this.f.markAsUninstalled(...b)}D(c,b){let p=this.b.get(c);p||this.b.set(c,p=new I.ResourceSet(d=>this.j.extUri.getComparisonKey(d))),p.add(b)}F(c,b){const p=this.b.get(c);p&&p.delete(b),p?.size||this.b.delete(c)}G(c,b){return`${k.ExtensionIdentifier.toKey(c.id)}@${b}`}H(c){const[b,p]=(0,D.getIdAndVersion)(c);return p?{identifier:{id:b},version:p}:void 0}}e.ExtensionsWatcher=w}),define(Z[136],Q([0,1,109,39]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function I(D,k,w,g,c,b,p){const d={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`};if((0,R.supportsTelemetry)(k,w)&&(0,R.getTelemetryLevel)(g)===3){const P=await(0,O.getServiceMachineId)(w,c,b),{machineId:m}=await p.getTelemetryInfo();d["X-Market-User-Id"]=P,d["VSCode-SessionId"]=m||P}return d}e.resolveMarketplaceHeaders=I}),define(Z[137],Q([0,1,164,19,5,2,16,14,20,17,24,26,6,63,12,11]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends P.LanguagePackBaseService{constructor(v,E,t,s){super(t),this.h=v,this.i=s,this.g=this.B(new f(E,s)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(v){const t=(await this.g.getLanguagePacks())[m.Language.value()];if(!t){this.i.warn(`No language pack found for ${m.Language.value()}`);return}const s=t.translations[v];return s?N.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),E=Object.keys(v).map(t=>{const s=v[t];return{...this.f(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((t,s)=>t.label.localeCompare(s.label)),E}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const E=await this.g.getLanguagePacks();Object.keys(E).some(t=>E[t]&&E[t].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(E);return!(0,R.equals)(Object.keys(v),Object.keys(t))}};u=fe([_(0,b.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,b.IExtensionGalleryService),_(3,d.ILogService)],u),e.NativeLanguagePackService=u;let f=class extends D.Disposable{constructor(v,E){super(),this.i=E,this.c={},this.f=(0,w.join)(v.userDataPath,"languagepacks.json"),this.g=new I.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(E=>{Object.keys(E).forEach(t=>delete E[t]),this.j(E,...v)}).then(()=>this.c)}j(v,...E){for(const t of E)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(v,t);Object.keys(v).forEach(t=>this.l(v[t]))}k(v,E){const t=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const i of s)if(E.location.scheme===k.Schemas.file&&y(i)){let n=v[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},v[i.languageId]=n);const r=n.extensions.filter(o=>(0,p.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=E.manifest.version:n.extensions.push({extensionIdentifier:t,version:E.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,w.join)(E.location.fsPath,o.path)}}l(v){if(v){const E=(0,O.createHash)("md5");for(const t of v.extensions)E.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);v.hash=E.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let E=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(E=v(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),g.Promises.writeFile(this.f,s)}).then(()=>E,t=>this.i.error(t))})}};f=fe([_(0,c.INativeEnvironmentService),_(1,d.ILogService)],f);function y(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const v of S.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(Z[138],Q([0,1,7,30,39]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function w(c,b,p){const d=await new Promise((f,y)=>{x(["@microsoft/1ds-core-js"],f,y)}),P=await new Promise((f,y)=>{x(["@microsoft/1ds-post-js"],f,y)}),m=new d.AppInsightsCore,N=new P.PostChannel,u={instrumentationKey:c,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[N]]};if(p){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:p};u.extensionConfig[N.identifier]=f}return m.initialize(u,[]),m.addTelemetryInitializer(f=>{b&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),m}class g{constructor(b,p,d,P,m){this.e=b,this.f=p,this.g=d,this.h=m,this.c=D,this.d=k,this.g||(this.g={}),typeof P=="function"?this.a=P():this.a=P,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(p=>{b(p)},p=>{(0,O.onUnexpectedError)(p),console.error(p)})}}log(b,p){if(!this.a)return;p=(0,R.mixin)(p,this.g),p=(0,I.validateTelemetryData)(p);const d=this.f+"/"+b;try{this.i(P=>{P.pluginVersionString=p?.properties.version??"Unknown",P.track({name:d,baseData:{name:d,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[139],Q([0,1,2,30,12,32,101,23,42,140,28,37,25,39]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(f,y,S){this.k=y,this.l=S,this.d={},this.i=new O.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(d.TELEMETRY_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,y){this.d[f]=y}m(){let f=(0,P.getTelemetryLevel)(this.k);const y=this.l.enabledTelemetryLevels;if(y){this.h=this.sendErrorTelemetry?y.error:!1;const S=y.usage?3:y.error?2:0;f=Math.min(f,S)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,y=f.sessionID,S=f["common.machineId"],v=f["common.firstSessionDate"],E=f["common.msftInternal"];return{sessionId:y,machineId:S,firstSessionDate:v,msftInternal:E}}dispose(){this.i.dispose()}n(f,y,S){return this.g<y?Promise.resolve(void 0):this.c.then(v=>{S=(0,R.mixin)(S,this.d),S=(0,P.cleanData)(S,this.j),S=(0,R.mixin)(S,v),this.b.forEach(E=>E.log(f,S))},v=>{console.error(v)})}publicLog(f,y){return this.n(f,3,y)}publicLog2(f,y){return this.publicLog(f,y)}publicLogError(f,y){return this.h?this.n(f,2,y):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([_(1,w.IConfigurationService),_(2,b.IProductService)],m),e.TelemetryService=m;function N(){const u=(0,k.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=I.isWeb?"":(0,k.localize)(3,null),S=(0,k.localize)(4,null),v=(0,k.localize)(5,null),E=(0,k.localize)(6,null),t=(0,k.localize)(7,null),s=`
|       | ${S} | ${v} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,k.localize)(8,null);return`
${u} ${f} ${y}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:N(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,k.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,k.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[141],Q([0,1,165,138]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class I extends R.AbstractOneDataSystemAppender{constructor(k,w,g,c){const b={sendPOST:(p,d)=>{const P={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const m=O.request(p.urlString,P,N=>{N.on("data",function(u){d(N.statusCode??200,N.headers,u.toString())}),N.on("error",function(u){d(0,{})})});m.write(p.data),m.end()}catch{d(0,{})}}};super(k,w,g,c,b)}}e.OneDataSystemAppender=I}),define(Z[142],Q([0,1,14,20]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function I(D,k){const w=Object.create(null),g=(b,p)=>{const d=JSON.parse(b);w[p]=d};if(k){const b=[],p=await R.Promises.readdir(k);for(const P of p)try{(await R.Promises.stat((0,O.join)(k,P))).isDirectory()&&b.push(P)}catch{}const d=[];for(const P of b)(await R.Promises.readdir((0,O.join)(k,P))).filter(N=>N==="telemetry.json").length===1&&d.push(P);for(const P of d){const m=(await R.Promises.readFile((0,O.join)(k,P,"telemetry.json"))).toString();g(m,P)}}let c=(await R.Promises.readFile((0,O.join)(D,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await R.Promises.readFile((0,O.join)(D,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=I}),define(Z[143],Q([0,1,12,80,25]),function(x,e,O,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(k){let w=k.getItem(I.machineIdKey);return(typeof w!="string"||O.isMacintosh&&w==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(w=await(0,R.getMachineId)()),w}e.resolveMachineId=D}),define(Z[27],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Z[144],Q([0,1,27,110,13,18,72,4,2]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let b=class{constructor(d){this.g=d,this.c=new g.DisposableStore,this.f=2**16;const P=new Map,m=N=>{let u=P.get(N.scheme);return u===void 0&&(u=d.hasProvider(N)&&!this.g.hasCapability(N,1024),P.set(N.scheme,u)),u};this.c.add(w.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(N=>{P.delete(N.scheme)})),this.extUri=new D.ExtUri(m),this.d=new k.SkipList((N,u)=>this.extUri.compare(N,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,D.normalizePath)(d));const P=this.d.get(d);return P?P.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((m,N)=>m[1].touch<N[1].touch?1:m[1].touch>N[1].touch?-1:0);c._clock=0,this.d.clear();const P=this.f*.5;for(let m=0;m<P;m++)this.d.set(d[m][0],d[m][1].touch())}};b=fe([_(0,I.IFileService)],b),e.UriIdentityService=b,(0,R.registerSingleton)(O.IUriIdentityService,b,1)}),define(Z[145],Q([0,1,103,14,54,18,11,10,16]),function(x,e,O,R,I,D,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function b(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=p;function d(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function P(i){const n=i;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=P;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function N(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=N;function u(i){const n=i;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(n,r,o,a,l){this.h=n,this.j=o,this.k=a,this.l=l,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function S(i){return new y({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function E(i){let n;return k.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=E;function t(i,n){return!v(i,n)&&!E(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,R.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Z[21],Q([0,1,51,4,2,18,11,102,17,13,10,6,145,36,27,5,31,32,3]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.isUserDataProfile=S,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function v(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:k.URI.revive(i.location).with({scheme:n}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=v;function E(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=E;let t=class extends I.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,a){super(),this.m=n,this.n=r,this.r=o,this.s=a,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new P.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const l of this.I()){if(!l.name||!(0,y.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(E((0,D.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}const r=new P.ResourceMap,o=new Map,a=this.v();if(n.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),n.length){const l=this.L();if(l.workspaces)for(const[h,A]of Object.entries(l.workspaces)){const F=k.URI.parse(h),Y=n.find(ee=>ee.id===A);Y&&r.set(F,Y)}if(l.emptyWindows)for(const[h,A]of Object.entries(l.emptyWindows)){const F=n.find(Y=>Y.id===A);F&&o.set(h,F)}}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}v(){return E("__default__profile__",(0,w.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const h of this.profiles){const A=o.exec(h.name),F=A?parseInt(A[1]):0;a=F>a?F:a}const l=`${r} ${a+1}`;return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(n,r,o);return a&&await this.setProfileForWorkspace(a,l),l}async w(n,r,o){if(!(0,y.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const l=this.profiles.find(F=>F.name===r||F.id===n);if(l)return l;const h=E(n,r,(0,D.joinPath)(this.profilesHome,n),o);await this.n.createFolder(h.location);const A=[];return this.h.fire({profile:h,join(F){A.push(F)}}),await N.Promises.settled(A),this.C([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=E(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return k.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,o){const a=[...this.profiles,...n],l=[];this.l.profiles=[];for(let h of a)h.isDefault||r.some(A=>h.id===A.id)||(h=o.find(A=>h.id===A.id)??h,h.isTransient?this.l.profiles.push(h):l.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.J(l),this.t=void 0,this.D(n,r,o)}D(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}F(n,r,o){o=r?.isTransient?!0:o,o||this.F(n,void 0,!0);const a=this.y(n),l=o?this.l:this.u;k.URI.isUri(a)?(l.workspaces.delete(a),r&&l.workspaces.set(a,r)):(l.emptyWindows.delete(a),r&&l.emptyWindows.set(a,r)),o||this.G()}G(){const n={};for(const[o,a]of this.u.workspaces.entries())n[o.toString()]=a.id;const r={};for(const[o,a]of this.u.emptyWindows.entries())r[o.toString()]=a.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},o=this.v();if(n.workspaces)for(const[l,h]of Object.entries(n.workspaces)){const A=k.URI.parse(h);r[l]=this.r.extUri.isEqual(A,o.location)?o.id:this.r.extUri.basename(A)}const a={};if(n.emptyWindows)for(const[l,h]of Object.entries(n.emptyWindows)){const A=k.URI.parse(h);a[l]=this.r.extUri.isEqual(A,o.location)?o.id:this.r.extUri.basename(A)}return{workspaces:r,emptyWindows:a}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=fe([_(0,g.IEnvironmentService),_(1,c.IFileService),_(2,m.IUriIdentityService),_(3,p.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=s}),define(Z[146],Q([0,1,19,5,22,7,4,2,12,11,87,24,26,29,6,28,25,21]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var y;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(y=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let S=class extends w.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,a,l){super(),this.t=n,this.u=r,this.v=o,this.w=a,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,w.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,p.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new p.ExtensionManagementError(b.localize(0,null),p.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),E(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,P.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},l=te=>`${d.ExtensionKey.create(te).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const te=this.j.get(l(r));if(te){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await te.task.waitUntilTaskIsFinished();return ie}}const h=[],A=[],F=[],Y=this.Q(n,r,a);c.URI.isUri(r)||this.j.set(l(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:a.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),h.push({task:Y,manifest:n});let ee=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ne=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:ae,manifest:ue}of(0,O.distinct)(ie,({gallery:se})=>se.identifier.id)){ee=ee||!!ue.extensionDependencies?.some(B=>(0,d.areSameExtensions)({id:B},Y.identifier));const se=l(ae),ve=this.j.get(se);if(ve){if(this.C(Y,ve.task)){const B=ve.task.identifier;this.v.info("Waiting for already requested installing extension",B.id,Y.identifier.id),ve.waitingTasks.push(Y),A.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,d.areSameExtensions)(M.identifier,B)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!j.find($=>(0,d.areSameExtensions)($.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ne.some(({identifier:B})=>(0,d.areSameExtensions)(B,ae.identifier))){const B=this.Q(ue,ae,{...a,donotIncludePackAndDependencies:!0});this.j.set(se,{task:B,waitingTasks:[Y]}),this.l.fire({identifier:B.identifier,source:ae,profileLocation:a.profileLocation}),this.v.info("Installing extension:",B.identifier.id,Y.identifier.id),h.push({task:B,manifest:ue})}}}catch(ie){if(c.URI.isUri(Y.source))(0,O.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,O.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const te=h.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(ue=>te.has(ue.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!ee)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.D(ie.map(async({task:ae})=>{const ue=new Date().getTime();try{const{local:se}=await ae.run();if(await this.D(this.s.map(ve=>ve.postInstall(se,ae.source,a,I.CancellationToken.None))),!c.URI.isUri(ae.source)){const ve=ae.operation===3,B=ve?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ve?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,durationSinceUpdate:B}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}F.push({local:se,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw c.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,error:se}),this.v.error("Error while installing the extension:",ae.identifier.id),se}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.D(A),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,Y.identifier))[0].local}catch(te){if(h.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:ue}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ue.id):this.v.warn("Rollback: Error while uninstalling extension",ue.id,(0,D.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:a.context,profileLocation:a.profileLocation}))),te}finally{for(const{task:te}of h)te.source&&!c.URI.isUri(te.source)&&this.j.delete(l(te.source))}}C(n,r){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(r)||a.some(l=>this.C(l,r)))||o===r&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const r=[],o=[],a=await Promise.allSettled(n);for(const l of a)l.status==="fulfilled"?r.push(l.value):o.push(l.reason);if(o.length)throw v(o);return r}async F(n,r,o,a,l){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,l),A=[],F=[],Y=async(ee,te)=>{A.push(ee);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=o?h.find(ue=>(0,d.areSameExtensions)(ue.identifier,ee)):void 0;for(const ue of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(se=>(0,d.areSameExtensions)({id:se},{id:ue}))||ne.every(se=>!(0,d.areSameExtensions)({id:se},{id:ue}))&&ne.push(ue)}if(ne.length){const ae=ne.filter(ue=>A.every(se=>!(0,d.areSameExtensions)(se,{id:ue})));if(ae.length){const ue=await this.t.getExtensions(ae.map(se=>({id:se,preRelease:a})),I.CancellationToken.None);for(const se of ue){if(A.find(j=>(0,d.areSameExtensions)(j,se.identifier)))continue;const ve=ie.some(j=>(0,d.areSameExtensions)({id:j},se.identifier));let B;try{B=await this.G(se,!1,a)}catch(j){if(j instanceof p.ExtensionManagementError&&j.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ve){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw j}F.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(n,r),F}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,d.areSameExtensions)(n.identifier,A)))throw new p.ExtensionManagementError(b.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new p.ExtensionManagementError(b.localize(2,null,n.identifier.id,this.w.nameLong,(0,p.TargetPlatformToString)(A)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,r,o);if(l){if(o&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(b.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],I.CancellationToken.None))[0]?new p.ExtensionManagementError(b.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(b.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const h=await this.t.getManifest(l,I.CancellationToken.None);if(h===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(h.version!==l.version)throw new p.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:h}}async H(n,r,o){const a=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},I.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,o,a)&&(l=n),l||(r?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},I.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,o,a)),l}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},a=ee=>`${ee.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,l=this.k.get(a(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const h=ee=>{const te=this.R(ee,o);return this.k.set(a(te.extension.identifier),te),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.n.fire({identifier:ee.identifier,profileLocation:o.profileLocation,applicationScoped:ee.isApplicationScoped}),te},A=(ee,te)=>{te?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,te.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(ee),error:te}),this.p.fire({identifier:ee.identifier,error:te?.code,profileLocation:o.profileLocation,applicationScoped:ee.isApplicationScoped})},F=[],Y=[];try{F.push(h(n));const ee=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.M(n,ee);for(const ie of te)this.k.has(a(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(h(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(te=>te.extension),ee,n),await this.D(F.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ie=>ie.postUninstall(te.extension,o,I.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}A(te.extension)}catch(ie){const ne=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,D.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw A(te.extension,ne),ne}finally{Y.push(te)}}))}catch(ee){const te=ee instanceof p.ExtensionManagementError?ee:new p.ExtensionManagementError((0,D.getErrorMessage)(ee),p.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Y.includes(ie)||A(ie.extension,te)}throw te}finally{for(const ee of F)this.k.delete(a(ee.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}J(n,r,o){for(const a of n){const l=this.N(a,r);if(l.length){const h=l.filter(A=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,A.identifier)));if(h.length)throw new Error(this.L(a,h,o))}}}L(n,r,o){return o===n?r.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const l=r.filter(A=>!A.isBuiltin&&a.some(F=>(0,d.areSameExtensions)({id:F},A.identifier))),h=[];for(const A of l)h.push(...this.M(A,r,o));return[...l,...h]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,d.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};S=fe([_(0,p.IExtensionGalleryService),_(1,u.ITelemetryService),_(2,m.ILogService),_(3,N.IProductService),_(4,f.IUserDataProfilesService)],S),e.AbstractExtensionManagementService=S;function v(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function E(i){if(i instanceof p.ExtensionManagementError)return i;const n=new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:a,error:l,durationSinceUpdate:h}){let A,F;l&&(l instanceof p.ExtensionManagementError?(A=l.code,l.code===p.ExtensionManagementErrorCode.Signature&&(F=l.message)):A=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!l,duration:a,errorcode:A,errorcodeDetail:F,durationSinceUpdate:h})}e.reportTelemetry=t;class s{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Z[40],Q([0,1,5,15,2,4,36,11,26,29,13,10,6,21,27,3,7,25]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var y;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(y=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class S extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let v=class extends I.Disposable{constructor(i,n,r,o,a,l){super(),this.h=i,this.i=n,this.j=r,this.k=o,this.l=a,this.m=l,this.a=this.B(new D.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new D.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new k.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.n(n,a=>{const l=[];for(const h of a)i.some(([A])=>(0,g.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version!==h.version)?r.push(h):l.push(h);for(const[h,A]of i)if(!l.some(F=>(0,g.areSameExtensions)(F.identifier,h.identifier)&&F.version===h.manifest.version)){const F={identifier:h.identifier,version:h.manifest.version,location:h.location,metadata:A};o.push(F),l.push(F)}return o.length&&this.a.fire({extensions:o,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),l}),o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),o}catch(a){throw o.length&&this.b.fire({extensions:o,error:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const r=[];return await this.n(n,o=>{const a=[];for(const l of o){const h=i.find(([A])=>(0,g.areSameExtensions)(A.identifier,l.identifier)&&A.manifest.version===l.version);h&&(l.metadata={...l.metadata,...h[1]},r.push(l)),a.push(l)}return a}),r}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,o=>{const a=[];for(const l of o)(0,g.areSameExtensions)(l.identifier,i.identifier)?r.push(l):a.push(l);return r.length&&this.c.fire({extensions:r,profileLocation:n}),a}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.f.fire({extensions:r,error:o,profileLocation:n}),o}}async n(i,n,r){return this.v(i).queue(async()=>{let o=[],a;try{const l=await this.i.readFile(i);a=JSON.parse(l.value.toString())}catch(l){if((0,b.toFileOperationResult)(l)!==1)throw l;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&r?.bailOutWhenFileNotFound)throw new S((0,u.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(i);let l=!1;for(const h of a){E(h)||this.p(i);let A;if((0,N.isString)(h.location))A=this.s(h.location);else{A=w.URI.revive(h.location);const F=this.r(A);F&&(l=!0,h.location=F)}o.push({identifier:h.identifier,location:A,version:h.version,metadata:h.metadata})}l&&await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(a)))}if(n){o=n(o);const l=o.map(h=>({identifier:h.identifier,version:h.version,location:this.r(h.location)??h.location.toJSON(),metadata:h.metadata}));await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(l)))}return o})}p(i){const n=new S(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(o){if((0,b.toFileOperationResult)(o)===1)return;throw o}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const o=JSON.parse(n);Array.isArray(o)&&o.every(a=>E(a))?r=o:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.m.error(o)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(o){if((0,b.toFileOperationResult)(o)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw o}try{await this.i.del(i)}catch(o){(0,b.toFileOperationResult)(o)!==1&&this.m.error(o)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new O.Queue,this.g.set(i,n)),n}};v=fe([_(1,b.IFileService),_(2,P.IUserDataProfilesService),_(3,m.IUriIdentityService),_(4,f.ITelemetryService),_(5,d.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function E(s){return(0,N.isObject)(s)&&(0,c.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,N.isString)(s.location))&&s.version&&(0,N.isString)(s.version)}function t(s){return s?(0,N.isString)(s.path)&&(0,N.isString)(s.scheme):!1}}),define(Z[47],Q([0,1,19,5,30,15,7,49,78,2,16,14,12,18,41,52,3,11,91,17,26,29,44,13,10,6,28,4,53,40,21,27,107,108]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S,v,E,t,s,i,n,r,o,a,l,h,A,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ee;(function(ve){function B(j,M){if(j===M)return!0;const $=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if($.length!==W.size)return!1;for(const q of $){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ve.equals=B})(ee=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends c.Disposable{constructor(B,j,M,$,W,q,J,C,L,T,U,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=M,this.m=$,this.n=W,this.p=q,this.r=J,this.s=C,this.t=L,this.u=T,this.v=U,this.w=V,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,P.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,P.joinPath)(this.m,E.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,P.joinPath)(this.m,E.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,M){const[$,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(B,[...$,...W]):[];return this.F($,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[M,$]=await Promise.all(j);return this.D([...M,...$],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),W=B.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions($)}catch(J){if(J instanceof l.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions($);else throw J}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter($=>$.scheme===b.Schemas.file).map(async $=>{const W=await this.J($,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(J=>(J.type=j.find(C=>(0,v.areSameExtensions)(C.identifier,J.identifier))?.type??J.type,this.k.validate(J,W)))}))).flat();return this.D(M,"development",B,!0)}return[]}async scanExistingExtension(B,j,M){const $=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension($);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,M){const $=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions($);return this.D(W,j,M,!0)}async scanMetadata(B){const j=(0,P.joinPath)(B,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,j){const M=(0,P.joinPath)(B,"package.json"),$=(await this.r.readFile(M)).value.toString(),W=JSON.parse($);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,P.joinPath)(B,"package.json"),D.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof l.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,M,$){return M.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),$)),M.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const J=p.basename(W.location.fsPath),C=p.basename(q.location.fsPath);return J<C?-1:J>C?1:0})}F(B,j,M,$,W){const q=(C,L,T)=>{if(C.isValid&&!L.isValid)return!1;if(C.isValid===L.isValid){if(W&&m.gt(C.manifest.version,L.manifest.version))return this.s.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${C.location.path} with version ${C.manifest.version}`),!1;if(m.eq(C.manifest.version,L.manifest.version)){if(C.type===0)return this.s.debug(`Skipping extension ${L.location.path} in favour of system extension ${C.location.path} with same version`),!1;if(C.targetPlatform===$)return this.s.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${C.location.path} with ${L.location.path}.`):this.s.debug(`Overwriting user extension ${C.location.path} with ${L.location.path}.`),!0},J=new Map;return B?.forEach(C=>{const L=E.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!1))&&J.set(L,C)}),j?.forEach(C=>{const L=E.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);if(!T&&B&&C.type===0){this.s.debug(`Skipping obsolete system extension ${C.location.path}.`);return}(!T||q(T,C,!1))&&J.set(L,C)}),M?.forEach(C=>{const L=E.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!0))&&J.set(L,C),J.set(L,C)}),[...J.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const $=j?await this.I():{},W=[],q=f.URI.file(p.normalize(p.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const C of M){const L=$[C.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":W.push((0,P.joinPath)(q,C.name));break;default:W.push(f.URI.file(L));break}}const J=await Promise.all(W.map(async C=>this.k.scanExtension(await this.J(C,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",J.length),(0,O.coalesce)(J)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,M,$,W,q,J){const C=await this.f(W??d.language),L=await this.L(B),T=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=T?await this.L(T):void 0;return new ie(B,L,T,U,j,J,M,$,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,C)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};te=fe([_(4,h.IUserDataProfilesService),_(5,l.IExtensionsProfileScannerService),_(6,s.IFileService),_(7,n.ILogService),_(8,S.IEnvironmentService),_(9,r.IProductService),_(10,A.IUriIdentityService),_(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(B,j,M,$,W,q,J,C,L,T,U,V,H,K,re){this.location=B,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=$,this.profile=W,this.profileScanOptions=q,this.type=J,this.excludeObsolete=C,this.validate=L,this.productVersion=T,this.productDate=U,this.productCommit=V,this.devMode=H,this.language=K,this.translations=re}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,P.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,P.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&I.equals(B.profileScanOptions,j.profileScanOptions)&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&ee.equals(B.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends c.Disposable{constructor(B,j,M,$,W){super(),this.f=B,this.g=j,this.h=M,this.i=$,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let M={};if(B.excludeObsolete&&B.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();M=JSON.parse($)}catch{}return(0,u.isEmptyObject)(M)?j:j.filter($=>!M[v.ExtensionKey.create($).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async $=>{if(!$.isDirectory||B.type===1&&(0,P.basename)($.resource).indexOf(".")===0)return null;const W=new ie($.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,O.coalesce)(M).sort(($,W)=>$.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter($=>!$.metadata?.isApplicationScoped);const M=await this.m(B.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,B);j.push(...M)}return j}async m(B,j,M){const $=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!$.length)return[];const W=await Promise.all($.map(async q=>{if(j(q)){const J=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(J,q.metadata)}return null}));return(0,O.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,P.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,k.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=E.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const $=(0,v.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:$,uuid:j.id}:{id:$},q=j?.isSystem?0:B.type,J=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(B.location,M,ie.createNlsConfiguration(B));const C={type:q,identifier:W,manifest:M,location:B.location,isBuiltin:J,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(C,B):C}}catch(M){B.type!==0&&this.j.error(M)}return null}validate(B,j){let M=!0;const $=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of $)W===N.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return B.isValid=M,B.validations=$,B}async scanExtensionManifest(B){const j=(0,P.joinPath)(B,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,y.localize)(0,null,j.path,W.message))),null}let $;try{$=JSON.parse(M)}catch{const q=[];(0,w.parse)(M,q);for(const J of q)this.j.error(this.t(B,(0,y.localize)(1,null,j.path,J.offset,J.length,(0,g.getParseErrorMessage)(J.error))));return null}return(0,w.getNodeType)($)!=="object"?(this.j.error(this.t(B,(0,y.localize)(2,null,j.path))),null):$}async n(B,j,M){const $=await this.p(B,j,M);if($)try{const W=[],q=await this.r($.default,W);if(W.length>0)return W.forEach(C=>{this.j.error(this.t(B,(0,y.localize)(3,null,$.default?.path,(0,g.getParseErrorMessage)(C.error))))}),j;if((0,w.getNodeType)($)!=="object")return this.j.error(this.t(B,(0,y.localize)(4,null,$.default?.path))),j;const J=$.values||Object.create(null);return(0,F.localizeManifest)(j,J,q)}catch{}return j}async p(B,j,M){const $=(0,P.joinPath)(B,"package.nls.json"),W=(L,T)=>{T.forEach(U=>{this.j.error(this.t(B,(0,y.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},q=L=>{this.j.error(this.t(B,(0,y.localize)(6,null,L?.path)))},J=`${j.publisher}.${j.name}`,C=M.translations[J];if(C)try{const L=f.URI.file(C),T=(await this.i.readFile(L)).value.toString(),U=[],V=(0,w.parse)(T,U);return U.length>0?(W(L,U),{values:void 0,default:$}):(0,w.getNodeType)(V)!=="object"?(q(L),{values:void 0,default:$}):{values:V.contents?V.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let T;try{T=await this.s(B,M)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.i.readFile(T.localized)).value.toString(),V=[],H=(0,w.parse)(U,V);return V.length>0?(W(T.localized,V),{values:void 0,default:T.original}):(0,w.getNodeType)(H)!=="object"?(q(T.localized),{values:void 0,default:T.original}):{values:H,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(B,j){if(B)try{const M=(await this.i.readFile(B)).value.toString();return(0,w.parse)(M,j)}catch{}}s(B,j){return new Promise((M,$)=>{const W=q=>{const J=(0,P.joinPath)(B,`package.nls.${q}.json`);this.i.exists(J).then(C=>{C&&M({localized:J,original:(0,P.joinPath)(B,"package.nls.json")});const L=q.lastIndexOf("-");L===-1?M({localized:(0,P.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,L),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,P.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ne=fe([_(1,l.IExtensionsProfileScannerService),_(2,A.IUriIdentityService),_(3,s.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(B,j,M,$,W,q){super(j,M,$,W,q),this.y=B,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",B.location.toString()),this.v.trigger(()=>this.D()),j.result.map($=>($.location=f.URI.revive($.location),$));const M=await super.scanExtensions(B);return await this.C({input:B,result:M}),M}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,k.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,k.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!I.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch($){this.j.error($)}}};ae=fe([_(2,l.IExtensionsProfileScannerService),_(3,A.IUriIdentityService),_(4,s.IFileService),_(5,n.ILogService)],ae);function ue(ve,B){const j=(0,v.getExtensionId)(ve.manifest.publisher,ve.manifest.name);return{id:j,identifier:new E.ExtensionIdentifier(j),isBuiltin:ve.type===0,isUserBuiltin:ve.type===1&&ve.isBuiltin,isUnderDevelopment:B,extensionLocation:ve.location,uuid:ve.identifier.uuid,targetPlatform:ve.targetPlatform,...ve.manifest}}e.toExtensionDescription=ue;class se extends te{constructor(B,j,M,$,W,q,J,C,L,T,U,V){super(B,j,(0,P.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,P.joinPath)($,E.MANIFEST_CACHE_FOLDER),W,q,J,C,L,T,U,V),this.M=(async()=>{if(d.translationsConfigFile)try{const H=await this.r.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=se}),define(Z[147],Q([0,1,57,5,34,4,2,16,14,20,6,21]),function(x,e,O,R,I,D,k,w,g,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(m,N){super(),this.b=m,this.f=N,this.a=new R.Limiter(5)}async postUninstall(m){const N=this.g(m,"uninstall");return N&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(N.script,"uninstall",N.args,!0,m).then(()=>this.f.info(m.identifier.id,m.manifest.version,"Finished running post uninstall script"),u=>this.f.error(m.identifier.id,m.manifest.version,`Failed to run post uninstall script: ${u}`)))),c.Promises.rm(this.j(m)).then(void 0,u=>this.f.error("Error while removing extension storage path",u))}g(m,N){const u=`vscode:${N}`;if(m.location.scheme===w.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[u]=="string"){const f=m.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${u} should be a node script`),null):{script:(0,g.join)(m.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(m,N,u,f,y){return new Promise((S,v)=>{const E=this.i(m,N,u,y);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?v(i):S(void 0)};E.on("error",i=>{s((0,I.toErrorMessage)(i)||"Unknown")}),E.on("exit",(i,n)=>{s(i?`post-${N} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,E.kill(),v("timed out")},5e3))})}i(m,N,u,f){const y={silent:!0,execArgv:void 0},S=(0,O.fork)(m,[`--type=extension-post-${N}`,...u],y);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const v=D.Event.fromNodeEventEmitter(S.stdout,"data"),E=D.Event.fromNodeEventEmitter(S.stderr,"data");v(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${N}`,i)),E(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${N}`,i));const t=D.Event.any(D.Event.map(v,i=>({data:`%c${i}`,format:[""]})),D.Event.map(E,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),S}j(m){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};d=fe([_(0,p.IUserDataProfilesService),_(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(Z[148],Q([0,1,6,21,27,25,40,13,17,11]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends k.AbstractExtensionsProfileScannerService{constructor(d,P,m,N,u,f){super(c.URI.file(d.extensionsPath),P,m,N,u,f)}};b=fe([_(0,g.INativeEnvironmentService),_(1,w.IFileService),_(2,R.IUserDataProfilesService),_(3,I.IUriIdentityService),_(4,D.ITelemetryService),_(5,O.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[149],Q([0,1,11,17,40,47,13,10,6,28,27,21]),function(x,e,O,R,I,D,k,w,g,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends D.NativeExtensionsScannerService{constructor(m,N,u,f,y,S,v,E){super(O.URI.file(y.builtinExtensionsPath),O.URI.file(y.extensionsPath),y.userHome,O.URI.file(y.userDataPath),m,N,u,f,y,S,v,E)}};d=fe([_(0,p.IUserDataProfilesService),_(1,I.IExtensionsProfileScannerService),_(2,k.IFileService),_(3,g.ILogService),_(4,R.INativeEnvironmentService),_(5,c.IProductService),_(6,b.IUriIdentityService),_(7,w.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(Z[150],Q([0,1,5,4,2,118,3,84,10,21]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function P(y){const S=y.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=P;class m extends I.Disposable{constructor(S={flushInterval:m.a}){super(),this.j=S,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new I.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,I.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(S,v){if(v===e.TARGET_KEY){switch(S){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:v,target:this.F(S)[v]})}r(S){this.f.fire({reason:S})}get(S,v,E){return this.L(v)?.get(S,E)}getBoolean(S,v,E){return this.L(v)?.getBoolean(S,E)}getNumber(S,v,E){return this.L(v)?.getNumber(S,E)}store(S,v,E,t){if((0,k.isUndefinedOrNull)(v)){this.remove(S,E);return}this.t(()=>{this.u(S,E,t),this.L(E)?.set(S,v)})}remove(S,v){this.t(()=>{this.u(S,v,void 0),this.L(v)?.delete(S)})}t(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,v){const E=[],t=this.F(S);for(const s of Object.keys(t))t[s]===v&&E.push(s);return E}u(S,v,E){const t=this.F(v);typeof E=="number"?t[S]!==E&&(t[S]=E,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(S){switch(S){case-1:return this.D;case 0:return this.z;default:return this.w}}G(S){const v=this.L(S);return v?P(v):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=b.NONE){this.f.fire({reason:S});const v=this.L(-1),E=this.L(0),t=this.L(1);switch(S){case b.NONE:await O.Promises.settled([v?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await O.Promises.settled([v?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return f(S,v,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(S,v){return this.r(b.NONE),(0,c.isUserDataProfile)(S)?this.N(S,v):this.O(S,v)}H(S,v){return!(S.id===v.id||N(v)&&N(S))}I(S,v,E,t){this.t(()=>{if(t)for(const[s,i]of S)v.set(s,i);else{const s=new Set;for(const[i,n]of S)s.add(i),v.get(i)!==n&&this.n(E,i);for(const[i]of v.items)s.has(i)||this.n(E,i)}})}}m.a=60*1e3,e.AbstractStorageService=m;function N(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=N;class u extends m{constructor(){super(),this.p=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(S=>this.n(1,S))),this.B(this.P.onDidChangeStorage(S=>this.n(0,S))),this.B(this.p.onDidChangeStorage(S=>this.n(-1,S)))}L(S){switch(S){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(S){return!1}}e.InMemoryStorageService=u;async function f(y,S,v,E,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;y.forEach((Y,ee)=>{n.set(ee,Y),r.set(ee,i(Y))});const o=new Map,a=new Map;S.forEach((Y,ee)=>{o.set(ee,Y),a.set(ee,i(Y))});const l=new Map,h=new Map;v.forEach((Y,ee)=>{l.set(ee,Y),h.set(ee,i(Y))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const A=[];if(n.forEach((Y,ee)=>{A.push({key:ee,value:Y})}),console.table(A),console.groupEnd(),console.log(r),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];o.forEach((ee,te)=>{Y.push({key:te,value:ee})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const F=[];l.forEach((Y,ee)=>{F.push({key:ee,value:Y})}),console.table(F),console.groupEnd(),console.log(h)}e.logStorage=f}),define(Z[151],Q([0,1,19,22,7,12,35,3,11,23,17,24,26,44,13,6,28,46,136,150,25]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const E=D.isWeb?"web":(0,p.getTargetPlatform)(D.platform,k.arch),t="X-Market-Search-Activity-Id";var s;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...L){return String(L.reduce((T,U)=>T|U,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(T=l){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,U=this.d.pageSize){return new h({...this.d,pageNumber:T,pageSize:U})}withFilter(T,...U){const V=[...this.d.criteria,...U.length?U.map(H=>({filterType:T,value:H})):[{filterType:T}]];return new h({...this.d,criteria:V})}withSortBy(T){return new h({...this.d,sortBy:T})}withSortOrder(T){return new h({...this.d,sortOrder:T})}withFlags(...T){return new h({...this.d,flags:T.reduce((U,V)=>U|V,0)})}withAssetTypes(...T){return new h({...this.d,assetTypes:T})}withSource(T){return new h({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:V,sortBy:H,sortOrder:K,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:T,pageNumber:U,pageSize:V,sortBy:H,sortOrder:K}],assetTypes:ce,flags:re}}get searchText(){const T=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(L,T){const U=(L||[]).filter(V=>V.statisticName===T)[0];return U?U.value:0}function F(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(V=>V.assetType.indexOf(T)===0).reduce((V,H)=>{const K=te(L,H.assetType);return K&&V.push([H.assetType.substring(T.length),K]),V},[])}function Y(L){if(L.properties){const T=L.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=T.filter(H=>U.test(H.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return te(L,r.Repository)}function ee(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function te(L,T){return L.files.filter(V=>V.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ie(L,T){const U=L.properties?L.properties.filter(H=>H.key===T):[],V=U.length>0&&U[0].value;return V?V.split(",").map(H=>(0,d.adoptToGalleryExtensionId)(H)):[]}function ne(L){const T=L.properties?L.properties.filter(U=>U.key===o.Engine):[];return T.length>0&&T[0].value||""}function ae(L){const T=L.properties?L.properties.filter(U=>U.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function ue(L){const T=L.properties?L.properties.filter(V=>V.key===o.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function se(L){return L.properties?.find(T=>T.key===o.SponsorLink)?.value}function ve(L){return L.indexOf("preview")!==-1}function B(L){return L.targetPlatform?(0,p.toTargetPlatform)(L.targetPlatform):"undefined"}function j(L){const T=(0,O.distinct)(L.versions.map(B)),U=!!L.tags?.includes(p.WEB_EXTENSION_TAG),V=T.indexOf("web");return U?V===-1&&T.push("web"):V!==-1&&T.splice(V,1),T}function M(L,T){const U=(0,p.getFallbackTargetPlarforms)(T);for(let V=0;V<L.length;V++){const H=L[V];if(H.version===L[V-1]?.version){let K=V;const re=B(H);if(re===T)for(;K>0&&L[K-1].version===H.version;)K--;else if(U.includes(re))for(;K>0&&L[K-1].version===H.version&&B(L[K-1])!==T;)K--;K!==V&&(L.splice(V,1),L.splice(K,0,H))}}return L}e.sortExtensionVersions=M;function $(L,T,U){L.telemetryData={index:T,querySource:U,queryActivityId:L.queryContext?.[t]}}function W(L,T,U,V){const H=L.versions[0],K={manifest:te(T,r.Manifest),readme:te(T,r.Details),changelog:te(T,r.Changelog),license:te(T,r.License),repository:Y(T),download:ee(T),icon:te(T,r.Icon),signature:te(T,r.Signature),coreTranslations:F(T)};return{identifier:{id:(0,d.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(H),description:L.shortDescription||"",installCount:A(L.statistics,"install"),rating:A(L.statistics,"averagerating"),ratingCount:A(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:K,properties:{dependencies:ie(T,o.Dependency),extensionPack:ie(T,o.ExtensionPack),engine:ne(T),localizedLanguages:ue(T),targetPlatform:B(T),isPreReleaseVersion:ae(T)},hasPreReleaseVersion:ae(H),hasReleaseVersion:!0,preview:ve(L.flags),isSigned:!!K.signature,queryContext:V}}let q=class{constructor(T,U,V,H,K,re,ce,we){this.k=U,this.l=V,this.n=H,this.o=K,this.q=re,this.u=ce,this.w=we;const me=ce.extensionsGallery,le=me?.servicePPEUrl&&we.getValue("_extensionsGallery.enablePPE");this.d=le?me.servicePPEUrl:me?.serviceUrl,this.g=le?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,y.resolveMarketplaceHeaders)(ce.version,ce,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,U,V){const H=R.CancellationToken.isCancellationToken(U)?{}:U,K=R.CancellationToken.isCancellationToken(U)?U:V,re=[],ce=[],we=[],me=[];let le=!0;for(const oe of T){oe.uuid?ce.push(oe.uuid):re.push(oe.id);const ye=!!(oe.version||oe.preRelease);we.push({id:oe.id,uuid:oe.uuid,includePreRelease:ye}),oe.version&&me.push({id:oe.id,uuid:oe.uuid,version:oe.version}),le=le&&!!oe.hasPreRelease&&!ye}if(!ce.length&&!re.length)return[];let de=new h().withPage(1,T.length);ce.length&&(de=de.withFilter(n.ExtensionId,...ce)),re.length&&(de=de.withFilter(n.ExtensionName,...re)),(H.queryAllVersions||le)&&(de=de.withFlags(de.flags,s.IncludeVersions)),H.source&&(de=de.withSource(H.source));const{extensions:ge}=await this.z(de,{targetPlatform:H.targetPlatform??E,includePreRelease:we,versions:me,compatible:!!H.compatible},K);return H.source&&ge.forEach((oe,ye)=>$(oe,ye,H.source)),ge}async getCompatibleExtension(T,U,V){if((0,p.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(T,U,V))return T;const H=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,T.identifier.uuid),{extensions:K}=await this.z(H,{targetPlatform:V,compatible:!0,includePreRelease:U},R.CancellationToken.None);return K[0]||null}async isExtensionCompatible(T,U,V){if(!(0,p.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,V)||!U&&T.properties.isPreReleaseVersion)return!1;let H=T.properties.engine;if(!H){const K=await this.getManifest(T,R.CancellationToken.None);if(!K)throw new Error("Manifest was not found");H=K.engines.vscode}return(0,P.isEngineValid)(H,this.u.version,this.u.date)}async y(T,U,V,H,K){if(!(0,p.isTargetPlatformCompatible)(B(T),H,K)||U!=="any"&&ae(T)!==(U==="prerelease"))return!1;if(V)try{const re=await this.E(T);if(!(0,P.isEngineValid)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,I.getErrorMessage)(re)),!1}return!0}async query(T,U){let V=T.text||"";const H=T.pageSize??50;let K=new h().withPage(1,H);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(K=K.withFilter(n.Category,ge||de),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(K=K.withFilter(n.Tag,ge||de),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(n.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),K=K.withFilter(n.SearchText,V)),K=K.withSortBy(0)):T.ids?K=K.withFilter(n.ExtensionId,...T.ids):T.names?K=K.withFilter(n.ExtensionName,...T.names):K=K.withSortBy(4),typeof T.sortBy=="number"&&(K=K.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(K=K.withSortOrder(T.sortOrder)),T.source&&(K=K.withSource(T.source));const re=async(le,de)=>{const{extensions:ge,total:oe}=await this.z(le,{targetPlatform:E,compatible:!1,includePreRelease:!!T.includePreRelease},de);return ge.forEach((ye,Se)=>$(ye,(le.pageNumber-1)*le.pageSize+Se,T.source)),{extensions:ge,total:oe}},{extensions:ce,total:we}=await re(K,U),me=async(le,de)=>{if(de.isCancellationRequested)throw new I.CancellationError;const{extensions:ge}=await re(K.withPage(le+1),de);return ge};return{firstPage:ce,total:we,pageSize:K.pageSize,getPage:me}}async z(T,U,V){const H=T.flags;!!(T.flags&s.IncludeLatestVersionOnly)&&!!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(T.flags&s.IncludeLatestVersionOnly)&&!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),T=T.withFlags(T.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:K,total:re,context:ce}=await this.B(T,V);if(!(T.flags&s.IncludeLatestVersionOnly)){const de=[];for(const ge of K){const oe=await this.A(ge,U,ce);oe&&de.push(oe)}return{extensions:de,total:re}}const me=[],le=new Map;for(let de=0;de<K.length;de++){const ge=K[de],oe={id:(0,d.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},ye=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ne=>(0,d.areSameExtensions)(Ne,oe))?.includePreRelease;if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(j(ge),U.targetPlatform))continue;const Se=await this.A(ge,U,ce);!Se||Se.properties.isPreReleaseVersion&&(!ye||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?le.set(ge.extensionId,de):me.push([de,Se])}if(le.size){const de=new Date().getTime(),ge=new h().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,le.size).withFilter(n.ExtensionId,...le.keys()),{extensions:oe}=await this.z(ge,U,V);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:le.size});for(const ye of oe){const Se=le.get(ye.identifier.uuid);me.push([Se,ye])}}return{extensions:me.sort((de,ge)=>de[0]-ge[0]).map(([,de])=>de),total:re}}async A(T,U,V){const H={id:(0,d.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},K=U.versions?.find(me=>(0,d.areSameExtensions)(me,H))?.version,re=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,H))?.includePreRelease,ce=j(T),we=M(T.versions,U.targetPlatform);if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ce,U.targetPlatform))return null;for(let me=0;me<we.length;me++){const le=we[me];if(!(K&&le.version!==K)){if(await this.y(le,re?"any":"release",U.compatible,ce,U.targetPlatform))return W(T,le,ce,V);if(K&&le.version===K)return null}}return K||U.compatible?null:W(T,T.versions[0],ce)}async B(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const V=await this.j,H=JSON.stringify(T.raw),K={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new Date().getTime();let ce,we,me=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&T.criteria.some(de=>de.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:K},U),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:me};const le=await(0,f.asJson)(ce);if(le){const de=le.results[0],ge=de.extensions,oe=de.resultMetadata&&de.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return me=oe&&oe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:me,context:{[t]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(le){throw we=le,le}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-re,success:!!ce&&(0,f.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:we?(0,I.isCancellationError)(we)?"canceled":(0,I.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(T,U,V,H){if(!this.isEnabled())return;const K=D.isWeb?this.x(`/itemName/${T}.${U}/version/${V}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${U}/${V}/stats?statType=${H}`),re=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:K,headers:we},R.CancellationToken.None)}catch{}}async download(T,U,V){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const H=(0,d.getGalleryExtensionTelemetryData)(T),K=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ce=V===2?"install":V===3?"update":"",we=ce?{uri:`${T.assets.download.uri}${g.URI.parse(T.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${T.assets.download.fallbackUri}${g.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:T.assets.download,me=T.queryContext?.[t]?{[t]:T.queryContext[t]}:void 0,le=await this.D(we,me?{headers:me}:void 0);await this.q.writeFile(U,le.stream),re(new Date().getTime()-K)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const V=await this.D(T.assets.signature);await this.q.writeFile(U,V.stream)}async getReadme(T,U){if(T.assets.readme){const V=await this.D(T.assets.readme,{},U);return await(0,f.asTextOrError)(V)||""}return""}async getManifest(T,U){if(T.assets.manifest){const V=await this.D(T.assets.manifest,{},U),H=await(0,f.asTextOrError)(V);return H?JSON.parse(H):null}return null}async C(T,U){const V=te(T,r.Manifest);if(!V)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},K=await this.D(V,{headers:H});return await(0,f.asJson)(K)}async getCoreTranslation(T,U){const V=T.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(V){const H=await this.D(V[1]),K=await(0,f.asTextOrError)(H);return K?JSON.parse(K):null}return null}async getChangelog(T,U){if(T.assets.changelog){const V=await this.D(T.assets.changelog,{},U);return await(0,f.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(T,U,V){let H=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?H=H.withFilter(n.ExtensionId,T.identifier.uuid):H=H.withFilter(n.ExtensionName,T.identifier.id);const{galleryExtensions:K}=await this.B(H,R.CancellationToken.None);if(!K.length)return[];const re=j(K[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(re,V))return[];const ce=[];await Promise.all(K[0].versions.map(async le=>{try{await this.y(le,U?"any":"release",!0,re,V)&&ce.push(le)}catch{}}));const we=[],me=new Set;for(const le of M(ce,V))me.has(le.version)||(me.add(le.version),we.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ae(le)}));return we}async D(T,U={},V=R.CancellationToken.None){const H=await this.j,K={type:"GET"},re={...H,...U.headers||{}};U={...U,...K,headers:re};const ce=T.uri,we=T.fallbackUri,me={...U,url:ce};try{const le=await this.k.request(me,V);if(le.res.statusCode===200)return le;const de=await(0,f.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${de}`)}catch(le){if((0,I.isCancellationError)(le))throw le;const de=(0,I.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const ge={...U,url:we};return this.k.request(ge,V)}}async E(T){let U=ne(T);if(!U){const V=await this.C(T,R.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const T=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(T),V=[],H={};if(U){for(const K of U.malicious)V.push({id:K});if(U.migrateToPreRelease)for(const[K,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,P.isEngineValid)(re.engine,this.u.version,this.u.date))&&(H[K.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[K,re]of Object.entries(U.deprecated))re&&(H[K.toLowerCase()]=(0,w.isBoolean)(re)?{}:re)}return{malicious:V,deprecated:H}}};q=fe([_(1,f.IRequestService),_(2,N.ILogService),_(3,b.IEnvironmentService),_(4,v.ITelemetryService),_(5,m.IFileService),_(6,u.IProductService),_(7,c.IConfigurationService)],q);let J=class extends q{constructor(T,U,V,H,K,re,ce,we){super(T,U,V,H,K,re,ce,we)}};J=fe([_(0,S.IStorageService),_(1,f.IRequestService),_(2,N.ILogService),_(3,b.IEnvironmentService),_(4,v.ITelemetryService),_(5,m.IFileService),_(6,u.IProductService),_(7,c.IConfigurationService)],J),e.ExtensionGalleryService=J;let C=class extends q{constructor(T,U,V,H,K,re,ce){super(void 0,T,U,V,H,K,re,ce)}};C=fe([_(0,f.IRequestService),_(1,N.ILogService),_(2,b.IEnvironmentService),_(3,v.ITelemetryService),_(4,m.IFileService),_(5,u.IProductService),_(6,c.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(Z[152],Q([0,1,3,11,17,13,6,67,27,21]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends c.UserDataProfilesService{constructor(P,m,N,u){super(m,N,P,u),this.a=m}N(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=fe([_(0,g.IUriIdentityService),_(1,I.INativeEnvironmentService),_(2,D.IFileService),_(3,k.ILogService)],b),e.ServerUserDataProfilesService=b;let p=class Ve extends b{constructor(P,m,N,u,f){super(m,N,u,f),this.Q=P}I(){return this.Q.getItem(Ve.b,[]).map(m=>({...m,location:(0,O.isString)(m.location)?this.r.extUri.joinPath(this.profilesHome,m.location):R.URI.revive(m.location)}))}L(){const P=this.Q.getItem(Ve.c,{});return this.Q.getItem(Ve.P,!1)?P:this.H(P)}N(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p.P="profileAssociationsMigration",p=fe([_(0,w.IStateService),_(1,g.IUriIdentityService),_(2,I.INativeEnvironmentService),_(3,D.IFileService),_(4,k.ILogService)],p),e.UserDataProfilesService=p}),define(Z[153],Q([0,1,38,5,166,2,6]),function(x,e,O,R,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=class extends O.AbstractPolicyService{constructor(c,b){super(),this.j=c,this.k=b,this.a=new R.Throttler,this.b=this.B(new D.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,p)=>{try{this.b.value=(0,I.createWatcher)(this.k,c,d=>{this.m(d),b()})}catch(d){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),p(d)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const p=c[b];p===void 0?this.g.delete(b):this.g.set(b,p)}this.h.fire(Object.keys(c))}};w=fe([_(0,k.ILogService)],w),e.NativePolicyService=w}),define(Z[69],Q([0,1,120,5,14,3,20,85,167,168]),function(x,e,O,R,I,D,k,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=b;function p(E){const t=E.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(E){if(E instanceof b)return E;let t;return/end of central directory record signature not found/.test(E.message)&&(t="CorruptZip"),new b(t,E)}function P(E,t,s,i,n,r){const o=I.dirname(t),a=I.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(w.localize(0,null,t)));const l=I.join(i,t);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(k.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,F)=>{if(!r.isCancellationRequested)try{h=(0,O.createWriteStream)(l,{mode:s}),h.once("close",()=>A()),h.once("error",F),E.once("error",F),E.pipe(h)}catch(Y){F(Y)}}))}function m(E,t,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),E.close()}),new Promise((o,a)=>{const l=new R.Sequencer,h=A=>{A.isCancellationRequested||(r++,E.readEntry())};E.once("error",a),E.once("close",()=>n.then(()=>{i.isCancellationRequested||E.entryCount===r?o():a(new b("Incomplete",new Error(w.localize(1,null,r,E.entryCount))))},a)),E.readEntry(),E.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){h(i);return}const F=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const te=I.join(t,F);n=(0,R.createCancelablePromise)(ie=>k.Promises.mkdir(te,{recursive:!0}).then(()=>h(ie)).then(void 0,a));return}const Y=u(E,A),ee=p(A);n=(0,R.createCancelablePromise)(te=>l.queue(()=>Y.then(ie=>P(ie,F,ee,t,s,te).then(()=>h(te)))).then(null,a))})})}function N(E,t=!1){return new Promise((s,i)=>{(0,g.open)(E,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,D.assertIsDefined)(r))})})}function u(E,t){return new Promise((s,i)=>{E.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,D.assertIsDefined)(r))})})}function f(E,t){return new Promise((s,i)=>{const n=new c.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,O.createWriteStream)(E);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(E))})}e.zip=f;function y(E,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=N(E,!0);return s.overwrite&&(r=r.then(o=>k.Promises.rm(t).then(()=>o))),r.then(o=>m(o,t,{sourcePathRegex:n},i))}e.extract=y;function S(E,t){return N(E).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&u(s,r).then(o=>i(o),o=>n(o))}),s.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function v(E,t){return S(E,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",o=>r.push(o)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=v}),define(Z[154],Q([0,1,69,93]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function I(D){return(0,O.buffer)(D,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=I}),define(Z[155],Q([0,1,5,22,34,7,4,2,36,16,14,12,18,41,3,11,31,20,69,92,58,17,146,24,26,40,47,134,147,154,127,135,29,44,13,10,6,28,25,27,21]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S,v,E,t,s,i,n,r,o,a,l,h,A,F,Y,ee,te,ie,ne,ae,ue,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,te.refineServiceDecorator)(s.IExtensionManagementService);let ve=class extends t.AbstractExtensionManagementService{constructor(C,L,T,U,V,H,K,re,ce,we,me,le){super(C,L,T,we,le),this.Z=V,this.ab=H,this.bb=K,this.cb=ce,this.db=me,this.X=this.B(new k.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new g.ResourceSet;const de=this.B(re.createInstance(a.ExtensionsLifecycle));this.S=this.B(re.createInstance(B,oe=>de.postUninstall(oe))),this.U=this.B(new h.ExtensionsManifestCache(U,this)),this.W=this.B(re.createInstance(o.ExtensionsDownloader));const ge=this.B(new A.ExtensionsWatcher(this,this.Z,le,H,me,ce,T));this.B(ge.onDidChangeExtensionsByAnotherSource(oe=>this.kb(oe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(C){this.v.trace("ExtensionManagementService#zip",C.identifier.id);const L=await this.jb(C),T=await(0,y.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,L);return N.URI.file(T)}async unzip(C){return this.v.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:L,cleanup:T}=await this.fb(C),U=b.resolve(L.fsPath);try{return await(0,l.getManifest)(U)}finally{await T()}}getInstalled(C,L){return this.S.scanExtensions(C??null,L)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(C,L={}){this.v.trace("ExtensionManagementService#install",C.toString());const{location:T,cleanup:U}=await this.fb(C);try{const V=await(0,l.getManifest)(b.resolve(T.fsPath));if(V.engines&&V.engines.vscode&&!(0,Y.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,T,L)}finally{await U()}}async installFromLocation(C,L){this.v.trace("ExtensionManagementService#installFromLocation",C.toString());const T=await this.S.scanUserExtensionAtLocation(C);if(!T)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([T],L),this.v.info("Successfully installed extension",T.identifier.id,L.toString()),T}getMetadata(C,L=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(C,L)}async updateMetadata(C,L,T=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",C.identifier.id),L.isPreReleaseVersion&&(L.preRelease=!0),L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.pinned=L.pinned||void 0,C=await this.S.updateMetadata(C,L,T),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const L=await this.getTargetPlatform(),[T]=await this.t.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:L,compatible:!0},R.CancellationToken.None);if(!T)throw new Error(S.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(U){throw new Error(S.localize(3,null,(0,I.toErrorMessage)(U)))}return this.installFromGallery(T)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(C,L){const{location:T}=await this.W.download(C,L);return T}async fb(C){if(C.scheme===c.Schemas.file)return{location:C,async cleanup(){}};this.v.trace("Downloading extension from",C.toString());const L=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(C,L),this.v.info("Downloaded extension to",L.toString()),{location:L,cleanup:async()=>{try{await this.cb.del(L)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(C,L,T){let U;if(N.URI.isUri(L))U=new $(C,L,T,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(L).toString();U=this.Y.get(V),U||(this.Y.set(V,U=new M(C,L,T,this.W,this.S,this.v)),U.waitUntilTaskIsFinished().then(()=>this.Y.delete(V)))}return new W(U,T.profileLocation,this.db,this.y,this.Z,this.ab)}R(C,L){return new q(C,L.profileLocation,this.ab)}async jb(C){const L=async U=>{let V=await f.Promises.readdir(U);V=V.map(re=>b.join(U,re));const H=await Promise.all(V.map(re=>f.Promises.stat(re)));let K=Promise.resolve([]);return H.forEach((re,ce)=>{const we=V[ce];re.isFile()&&(K=K.then(me=>[...me,we])),re.isDirectory()&&(K=K.then(me=>L(we).then(le=>[...me,...le])))}),K};return(await L(C.location.fsPath)).map(U=>({path:`extension/${b.relative(C.location.fsPath,U)}`,localPath:U}))}async kb({added:C,removed:L}){if(L)for(const T of L.extensions)this.v.info("Extensions removed from another source",T.id,L.profileLocation.toString()),this.p.fire({identifier:T,profileLocation:L.profileLocation});if(C){const U=(await this.S.scanExtensions(1,C.profileLocation)).filter(V=>C.extensions.some(H=>(0,i.areSameExtensions)(H,V.identifier)));this.m.fire(U.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,C.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(L=>this.lb.add(L)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const L of C.children??[])L.isDirectory&&this.lb.add(L.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(L=>this.nb(L)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const L=[];for(const T of C.rawAdded){if(this.lb.has(T)||!this.db.extUri.isEqual(this.db.extUri.dirname(T),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(T,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(T).startsWith(".")||!(await this.cb.stat(T)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(T);U&&U.installedTimestamp===void 0&&(this.lb.add(T),L.push(U))}L.length&&(await this.ob(L,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",L.map(T=>T.identifier.id)))}async ob(C,L){await this.ab.addExtensionsToProfile(C.map(T=>[T,void 0]),L),this.m.fire(C.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:L})))}};ve=fe([_(0,s.IExtensionGalleryService),_(1,ae.ITelemetryService),_(2,ie.ILogService),_(3,E.INativeEnvironmentService),_(4,r.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,v.IDownloadService),_(7,te.IInstantiationService),_(8,ee.IFileService),_(9,ne.IProductService),_(10,ue.IUriIdentityService),_(11,se.IUserDataProfilesService)],ve),e.ExtensionManagementService=ve;let B=class extends w.Disposable{constructor(C,L,T,U,V){super(),this.j=C,this.k=L,this.l=T,this.m=U,this.n=V,this.h=this.B(new k.Emitter),this.onExtract=this.h.event,this.c=(0,d.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new O.Queue}async cleanUp(){await this.w()}async scanExtensions(C,L){const T={includeInvalid:!0,profileLocation:L};let U=[];return C===null||C===0?U.push(...await this.l.scanAllExtensions({includeInvalid:!0},T,!1)):C===1&&U.push(...await this.l.scanUserExtensions(T)),U=C!==null?U.filter(V=>V.type===C):U,Promise.all(U.map(V=>this.v(V)))}async scanAllUserExtensions(C){const L=await this.l.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(L.map(T=>this.v(T)))}async scanUserExtensionAtLocation(C){try{const L=await this.l.scanExistingExtension(C,1,{includeInvalid:!0});if(L)return await this.v(L)}catch(L){this.n.error(L)}return null}async extractUserExtension(C,L,T,U){const V=C.toString(),H=b.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),K=b.join(this.l.userExtensionsLocation.fsPath,V);try{await f.Promises.rm(K)}catch{throw new s.ExtensionManagementError(S.localize(4,null,K,C.id),s.ExtensionManagementErrorCode.Delete)}await this.s(C,L,H,U),await this.l.updateMetadata(N.URI.file(H),T);try{this.h.fire(N.URI.file(K)),await this.t(C,H,K,Date.now()+2*60*1e3),this.n.info("Renamed to",K)}catch(re){try{await f.Promises.rm(H)}catch{}if(re.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.n.info(`Rename failed because of ${(0,D.getErrorMessage)(re)}. Deleted from extracted location`,H),re}return this.u(N.URI.file(K),1)}async scanMetadata(C,L){return L?(await this.m.scanProfileExtensions(L)).find(U=>(0,i.areSameExtensions)(U.identifier,C.identifier))?.metadata:this.l.scanMetadata(C.location)}async updateMetadata(C,L,T){return T?await this.m.updateMetadata([[C,L]],T):await this.l.updateMetadata(C.location,L),this.u(C.location,C.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...C){const L=C.map(T=>i.ExtensionKey.create(T));await this.p(T=>L.forEach(U=>{T[U.toString()]=!0,this.n.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(C){await this.p(U=>delete U[C.toString()]);const T=(await this.scanAllUserExtensions(!0)).find(U=>i.ExtensionKey.create(U).equals(C))||null;return T?this.updateMetadata(T,{installedTimestamp:Date.now()}):null}async removeExtension(C,L){this.n.trace(`Deleting ${L} extension from disk`,C.identifier.id,C.location.fsPath),await f.Promises.rm(C.location.fsPath),this.n.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.p(L=>delete L[i.ExtensionKey.create(C).toString()])}async p(C){return this.g.queue(async()=>{let L;try{L=await f.Promises.readFile(this.c,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let T={};if(L)try{T=JSON.parse(L)}catch{}return C&&(C(T),Object.keys(T).length?await f.Promises.writeFile(this.c,JSON.stringify(T)):await f.Promises.rm(this.c)),T})}async s(C,L,T,U){this.n.trace(`Started extracting the extension from ${L} to ${T}`);try{await f.Promises.rm(T)}catch(V){throw new s.ExtensionManagementError(this.y(V).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(L,T,{sourcePath:"extension",overwrite:!0},U),this.n.info(`Extracted extension to ${T}:`,C.id)}catch(V){try{await f.Promises.rm(T)}catch{}let H=s.ExtensionManagementErrorCode.Extract;throw V instanceof y.ExtractError&&(V.type==="CorruptZip"?H=s.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(H=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(V.message,H)}}async t(C,L,T,U){try{await f.Promises.rename(L,T)}catch(V){if(p.isWindows&&V&&V.code==="EPERM"&&Date.now()<U)return this.n.info(`Failed renaming ${L} to ${T} with 'EPERM' error. Trying again...`,C.id),this.t(C,L,T,U);throw new s.ExtensionManagementError(V.message||S.localize(5,null,L,T),V.code||s.ExtensionManagementErrorCode.Rename)}}async u(C,L){const T=await this.l.scanExistingExtension(C,L,{includeInvalid:!0});if(T)return this.v(T);throw new Error(S.localize(6,null,C.path))}async v(C){const L=await this.k.resolve(C.location);let T,U;return L.children&&(T=L.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,U=L.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:T,changelogUrl:U,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async w(){const C=await this.getUninstalledExtensions(),L=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const H of L)C[i.ExtensionKey.create(H).toString()]||T.add(H.identifier.id.toLowerCase());const U=(0,i.groupByExtension)(L,H=>H.identifier);await O.Promises.settled(U.map(async H=>{const K=H.sort((re,ce)=>P.rcompare(re.manifest.version,ce.manifest.version))[0];T.has(K.identifier.id.toLowerCase())||await this.j(await this.v(K))}));const V=L.filter(H=>H.metadata&&C[i.ExtensionKey.create(H).toString()]);await O.Promises.settled(V.map(H=>this.removeUninstalledExtension(H)))}y(C){const L=Array.isArray(C)?C:[C];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((T,U)=>new Error(`${T.message}${T.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};B=fe([_(1,ee.IFileService),_(2,r.IExtensionsScannerService),_(3,n.IExtensionsProfileScannerService),_(4,ie.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,m.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,L,T,U,V){super(),this.identifier=C,this.source=L,this.l=T,this.m=U,this.n=V,this.j="Unverified",this.k=2}async o(C,L){try{const T=await this.p(C.key);if(T)return this.m.updateMetadata(T,C.metadata)}catch{throw p.isMacintosh?new s.ExtensionManagementError(S.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(S.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.s(C,L)}async p(C){if(!await this.q(C))return null;this.n.trace("Removing the extension from uninstalled list:",C.id);const T=await this.m.setInstalled(C);return this.n.info("Removed the extension from uninstalled list:",C.id),T}async q(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}async s({zipPath:C,key:L,metadata:T},U){const V=await this.m.extractUserExtension(L,C,T,U);return this.n.info("Extracting completed.",L.id),V}}class M extends j{constructor(C,L,T,U,V,H){super(L.identifier,L,T,V,H),this.t=C,this.u=L,this.v=U}async h(C){const T=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,i.areSameExtensions)(K.identifier,this.u.identifier));T&&(this.k=3);const U={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,F.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||T?.isMachineScoped,isBuiltin:this.l.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,m.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(T,U),metadata:U};const{location:V,verificationStatus:H}=await this.v.download(this.u,this.k);try{return this.j=H,this.x(V.fsPath),{local:await this.o({zipPath:V.fsPath,key:i.ExtensionKey.create(this.u),metadata:U},C),metadata:U}}catch(K){try{await this.v.delete(V)}catch(re){this.n.warn("Error while deleting the downloaded file",V.toString(),(0,D.getErrorMessage)(re))}throw K}}async x(C){try{await(0,l.getManifest)(C)}catch(L){throw new s.ExtensionManagementError((0,t.joinErrors)(L).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class $ extends j{constructor(C,L,T,U,V,H){super({id:(0,i.getGalleryExtensionId)(C.publisher,C.name)},L,T,V,H),this.t=C,this.u=L,this.v=U}async h(C){const L=new i.ExtensionKey(this.identifier,this.t.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,i.areSameExtensions)(this.identifier,K.identifier)),V=await this.x(this.identifier.id,this.t.version,C);if(V.isApplicationScoped=(0,F.isApplicationScopedExtension)(this.t),V.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,V.isBuiltin=this.l.isBuiltin||U?.isBuiltin,V.installedTimestamp=Date.now(),V.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,L.equals(new i.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(S.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&P.gt(U.manifest.version,this.t.version)&&await this.m.setUninstalled(U);else{const K=await this.p(L);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(S.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:b.resolve(this.u.fsPath),key:L,metadata:V},C),metadata:V}}async x(C,L,T){try{let[U]=await this.v.getExtensions([{id:C,version:L}],T);if(U||([U]=await this.v.getExtensions([{id:C}],T)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get operation(){return this.d.operation}get verificationStatus(){return this.d.verificationStatus}constructor(C,L,T,U,V,H){this.d=C,this.g=L,this.h=T,this.j=U,this.k=V,this.l=H,this.identifier=this.d.identifier,this.source=this.d.source,this.c=this.m()}async m(){const C=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[C.local,C.metadata]],this.g),C}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(C,L,T){super(),this.extension=C,this.j=L,this.k=T}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[156],Q([0,1,130,5,15,7,2,3,23,17,131,6,129,169]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends k.Disposable{constructor(u,f,y){super(),this.h=u,this.i=f,this.j=y,this.k(),this.B(u.onDidChangeConfiguration(S=>{S.affectsConfiguration("http")&&this.k()}))}k(){const u=this.h.getValue("http");this.a=u?.proxy,this.b=!!u?.proxyStrictSSL,this.f=u?.proxyAuthorization}async request(u,f){this.j.trace("RequestService#request (node) - begin",u.url);const{a:y,b:S}=this;let v;try{v=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const E={...process.env,...v},t=u.agent?u.agent:await(0,d.getProxyAgent)(u.url||"",E,{proxyUrl:y,strictSSL:S});u.agent=t,u.strictSSL=S,this.f&&(u.headers={...u.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(u,f);return this.j.trace("RequestService#request (node) - success",u.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",u.url,s),s}}async l(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((S,v)=>{x(["https"],S,v)}):await new Promise((S,v)=>{x(["http"],S,v)})).request}m(u,f){return R.Promises.withAsyncBody(async(y,S)=>{const v=(0,O.parse)(u.url),E=u.getRawRequest?u.getRawRequest(u):await this.l(u),t={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,w.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const s=E(t,i=>{const n=(0,w.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...u,url:i.headers.location,followRedirects:n-1},f).then(y,S);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,P.createGunzip)())),y({res:i,stream:(0,I.streamToBufferReadableStream)(r)})}});s.on("error",S),u.timeout&&s.setTimeout(u.timeout),u.isChromiumNetwork&&s.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&s.write(u.data),s.end(),f.onCancellationRequested(()=>{s.abort(),S(new D.CancellationError)})})}async resolveProxy(u){}};m=fe([_(0,g.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,p.ILogService)],m),e.RequestService=m}),define(Z[170],Q([0,1,33,5,15,34,7,2,16,14,12,35,11,20,23,126,58,128,17,106,151,24,59,133,40,47,155,149,13,117,119,45,115,62,63,137,6,122,123,38,153,140,28,46,156,67,132,68,25,139,39,141,142,27,144,21,152,143,148,121]),function(x,e,O,R,I,D,k,w,g,c,b,p,d,P,m,N,u,f,y,S,v,E,t,s,i,n,r,o,a,l,h,A,F,Y,ee,te,ie,ne,ae,ue,se,ve,B,j,M,$,W,q,J,C,L,T,U,V,H,K,re,ce,we,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends w.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,ye]=await this.f();return oe.invokeFunction(async Se=>{const Ne=Se.get(ie.ILogService),Fe=Se.get(a.IFileService),z=Se.get(y.INativeEnvironmentService),G=Se.get(K.IUserDataProfilesService);Ne.info("CLI main",this.b),this.g(Ne),await this.h(z,Fe,G,oe),await Promise.all(ye.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,ye={_serviceBrand:void 0,...ve.default};oe.set(B.IProductService,ye);const Se=new S.NativeEnvironmentService(this.b,ye);oe.set(y.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(Re=>Re?P.Promises.mkdir(Re,{recursive:!0}):void 0));const Ne=(0,ie.getLogLevel)(Se),Fe=new ne.SpdLogLogger("cli",(0,c.join)(Se.logsPath,"cli.log"),!0,!1,Ne),z=[];Ne===ie.LogLevel.Trace&&z.push(new ie.ConsoleLogger(Ne));const G=this.B(new me.LogService(Fe,z));oe.set(ie.ILogService,G);const X=this.B(new l.FileService(G));oe.set(a.IFileService,X);const he=this.B(new h.DiskFileSystemProvider(G));X.registerProvider(g.Schemas.file,he);const pe=new W.StateService(Se,G,X);oe.set($.IStateService,pe);const Oe=new H.UriIdentityService(X);oe.set(V.IUriIdentityService,Oe);const Ie=new re.UserDataProfilesService(pe,Oe,Se,X,G);oe.set(K.IUserDataProfilesService,Ie);const Ae=b.isWindows&&ye.win32RegValueName?this.B(new se.NativePolicyService(G,ye.win32RegValueName)):Se.policyFile?this.B(new ae.FilePolicyService(Se.policyFile,X,G)):new ue.NullPolicyService;oe.set(ue.IPolicyService,Ae);const ke=this.B(new N.ConfigurationService(Ie.defaultProfile.settingsResource,X,Ae,G));oe.set(m.IConfigurationService,ke),await Promise.all([pe.init(),ke.initialize()]),Ie.init(),oe.set(V.IUriIdentityService,new H.UriIdentityService(X)),oe.set(j.IRequestService,new A.SyncDescriptor(M.RequestService,void 0,!0)),oe.set(u.IDownloadService,new A.SyncDescriptor(f.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(we.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new A.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),oe.set(E.IExtensionGalleryService,new A.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(ee.ILanguagePackService,new A.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Te=[],Ue=(0,L.isInternalTelemetry)(ye,ke);if((0,L.supportsTelemetry)(ye,Se)){ye.aiConfig&&ye.aiConfig.ariaKey&&Te.push(new T.OneDataSystemAppender(Ue,"monacoworkbench",null,ye.aiConfig.ariaKey));const{installSourcePath:Re}=Se,Le={appenders:Te,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,ce.resolveMachineId)(pe)}catch(je){je.code!=="ENOENT"&&G.error(je)}return(0,q.resolveCommonProperties)(X,(0,O.release)(),(0,O.hostname)(),process.arch,ye.commit,ye.version,Ce,Ue,Re)})(),piiPaths:(0,L.getPiiPathsFromEnvironment)(Se)};oe.set(J.ITelemetryService,new A.SyncDescriptor(C.TelemetryService,[Le],!1))}else oe.set(J.ITelemetryService,L.NullTelemetryService);return[new F.InstantiationService(oe),Te]}g(oe){(0,k.setUnexpectedErrorHandler)(ye=>{const Se=(0,D.toErrorMessage)(ye,!0);!Se||oe.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ye=>{(0,k.isSigPipeError)(ye)||(0,k.onUnexpectedError)(ye)}),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye))}async h(oe,ye,Se,Ne){let Fe;if(oe.args.profile&&(Fe=Se.profiles.find(G=>G.name===oe.args.profile),!Fe))throw new Error(`Profile '${oe.args.profile}' not found.`);const z=(Fe??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,ye,this.b["install-source"]);if(this.b["list-extensions"])return Ne.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,z);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const G={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:z};return Ne.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],G,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ne.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,z);if(this.b["locate-extension"])return Ne.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(ye=>/\.vsix$/i.test(ye)?d.URI.file((0,c.isAbsolute)(ye)?ye:(0,c.join)((0,p.cwd)(),ye)):ye)}async j(oe,ye,Se){await ye.writeFile(d.URI.file(oe.installSourcePath),I.VSBuffer.fromString(Se.slice(0,30)))}}async function de(ge){const oe=new le(ge);try{await oe.run()}finally{oe.dispose()}}e.main=de})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b214a0937bfa76b08512cdd57c83d92659f14fab/core/vs/code/node/cliProcessMain.js.map
